/*
 *   jsWorkFlow
 *   Copyright(c) 2012, Yin Mingjun.
 * 
 *  jsWorkFlow's Project
 *      2012.03.06: Create By Yin Mingjun - email: yinmingjuncn@gmail.com
 *   
 *   Copyright 2012,  Yin MingJun - email: yinmingjuncn@gmail.com
 *   Dual licensed under the MIT or GPL Version 2 licenses.
 *   http://jquery.org/license
 *  
 */


var jso=null;if(typeof(jsoop)==='undefined'){jso=require('jsoop');}
else{jso=jsoop;}
jso.registerNamespace('jsWorkFlow');jso.registerNamespace('jsWorkFlow.Activities');var jsWorkFlow=jso.ns('jsWorkFlow');exports.rootns=jsWorkFlow;function jsWorkFlow$setInterval(handler,interval){var retval=setInterval(handler,interval);return retval;}
function jsWorkFlow$clearInterval(intervalID){clearInterval(intervalID);}
function jsWorkFlow$setTimeout(handler,delay){var retval=setTimeout(handler,delay);return retval;}
function jsWorkFlow$clearTimeout(timeoutID){clearTimeout(timeoutID);}
jsWorkFlow.setInterval=jsWorkFlow$setInterval;jsWorkFlow.clearInterval=jsWorkFlow$clearInterval;jsWorkFlow.setTimeout=jsWorkFlow$setTimeout;jsWorkFlow.clearTimeout=jsWorkFlow$clearTimeout;jsWorkFlow.ActivityState=function jsWorkFlow_ActivityState(){throw jso.errorNotImplemented();};jsWorkFlow.ActivityState.prototype={none:0,start:1,end:2,error:3};jsWorkFlow.ActivityState.min_value=100;jso.registerEnum(jso.setTypeName(jsWorkFlow.ActivityState,'jsWorkFlow.ActivityState'));jsWorkFlow.Events=function jsWorkFlow_Events(owner){this._owner=owner;this._events=new jso.EventHandlerList();};function jsWorkFlow_Events$dispose(){this._owner=null;this._events=null;}
function jsWorkFlow_Events$get_events(){return this._events;}
function jsWorkFlow_Events$addHandler(eventName,handler){this._events.addHandler(eventName,handler);}
function jsWorkFlow_Events$removeHandler(eventName,handler){this._events.removeHandler(eventName,handler);}
function jsWorkFlow_Events$raiseEvent(eventName,eventArgs){this._events.raiseEvent(eventName,this._owner,eventArgs);}
jsWorkFlow.Events.prototype={_owner:null,_events:null,dispose:jsWorkFlow_Events$dispose,get_events:jsWorkFlow_Events$get_events,addHandler:jsWorkFlow_Events$addHandler,removeHandler:jsWorkFlow_Events$removeHandler,raiseEvent:jsWorkFlow_Events$raiseEvent};jso.registerClass(jso.setTypeName(jsWorkFlow.Events,'jsWorkFlow.Events'));jsWorkFlow.Application=function jsWorkFlow_Application(instance,dataContext){var log=jwf$getLogger();log.debug("Application create!");this._events=new jsWorkFlow.Events(this);this._instance=instance;if(!dataContext){dataContext={};}
this._dataContext=dataContext;this._scheduler=new jsWorkFlow.Scheduler();this._scheduler_stop_handler=jso.createDelegate(this,this.scheduler_stop_handler);this._scheduler.add_stop(this._scheduler_stop_handler);};function jsWorkFlow_Application$get_scheduler(){return this._scheduler;}
function jsWorkFlow_Application$get_globalContext(){var ins=jsWorkFlow.GlobalContext.getInstance();return ins;}
function jsWorkFlow_Application$get_appContext(){return this._appContext;}
function jsWorkFlow_Application$get_instance(){return this._instance;}
function jsWorkFlow_Application$get_currentContext(){var contextStack=this._contextStack;var context=contextStack[contextStack.length-1];return context;}
function jsWorkFlow_Application$run(keepRunning){var log=jwf$getLogger();log.debug("Application run!");this._appContext=new jsWorkFlow.ApplicationContext();if(this._dataContext){var dst=this._appContext;for(var key in this._dataContext){if(!this._dataContext.hasOwnProperty(key)){continue;}
dst.setData(key,this._dataContext[key]);}}
this._contextStack=[];this._scheduler.start();this._events.raiseEvent('start',jso.EventArgs.Empty);this._instance.execute(this);if(!keepRunning){this._scheduler.stop();}}
function jsWorkFlow_Application$scheduler_stop_handler(){this._events.raiseEvent('stop',jso.EventArgs.Empty);}
function jsWorkFlow_Application$dispose(){var log=jwf$getLogger();log.debug("Application dispose!");this._events.dispose();this._instance.dispose();this._scheduler.dispose();this._appContext.dispose();this._events=null;this._instance=null;this._scheduler=null;this._appContext=null;this._contextStack=null;this._scheduler_stop_handler=null;}
function jsWorkFlow_Application$pushContextStack(activityContext){this._contextStack.push(activityContext);}
function jsWorkFlow_Application$popContextStack(){var activityContext=this._contextStack.pop();return activityContext;}
function jsWorkFlow_Application$internalContextAt(index){var contextStack=this._contextStack;var activityContext=contextStack[contextStack.length-1-index];return activityContext;}
function jsWorkFlow_Application$getDataItem(key,localContextIndex){if(typeof(localContextIndex)==="undefined"){localContextIndex=0;}
var dataItem=null;var contextStack=this._contextStack;for(var i=contextStack.length-1;i>=0;i--){var context=contextStack[i];dataItem=context.getDataItem(key);if(dataItem&&(i>=(contextStack.length-localContextIndex-1))){return dataItem;}
if(dataItem&&dataItem.isPublic){return dataItem;}}
dataItem=this._appContext.getDataItem(key);if(dataItem&&dataItem.isPublic){return dataItem;}
var globalContext=this.get_globalContext();dataItem=globalContext.getDataItem(key);if(dataItem&&dataItem.isPublic){return dataItem;}
return null;}
function jsWorkFlow_Application$getData(key,localContextIndex){var dataItem=this.getDataItem(key,localContextIndex);if(dataItem){return dataItem.value;}
return null;}
function jsWorkFlow_Application$setData(key,value,localContextIndex){var dataItem=this.getDataItem(key,localContextIndex);if(dataItem){dataItem.value=value;return;}
var context=this.internalContextAt(localContextIndex);context.setData(key,value);}
function jsWorkFlow_Application$add_start(handler){this._events.addHandler('start',handler);}
function jsWorkFlow_Application$remove_start(handler){this._events.removeHandler('start',handler);}
function jsWorkFlow_Application$add_stop(handler){this._events.addHandler('stop',handler);}
function jsWorkFlow_Application$remove_stop(handler){this._events.removeHandler('stop',handler);}
jsWorkFlow.Application.prototype={_instance:null,_dataContext:null,_appContext:null,_contextStack:null,_events:null,_scheduler:null,_scheduler_stop_handler:null,get_scheduler:jsWorkFlow_Application$get_scheduler,get_globalContext:jsWorkFlow_Application$get_globalContext,get_appContext:jsWorkFlow_Application$get_appContext,get_instance:jsWorkFlow_Application$get_instance,get_currentContext:jsWorkFlow_Application$get_currentContext,run:jsWorkFlow_Application$run,scheduler_stop_handler:jsWorkFlow_Application$scheduler_stop_handler,dispose:jsWorkFlow_Application$dispose,pushContextStack:jsWorkFlow_Application$pushContextStack,popContextStack:jsWorkFlow_Application$popContextStack,internalContextAt:jsWorkFlow_Application$internalContextAt,getDataItem:jsWorkFlow_Application$getDataItem,getData:jsWorkFlow_Application$getData,setData:jsWorkFlow_Application$setData,add_start:jsWorkFlow_Application$add_start,remove_start:jsWorkFlow_Application$remove_start,add_stop:jsWorkFlow_Application$add_stop,remove_stop:jsWorkFlow_Application$remove_stop};jso.registerClass(jso.setTypeName(jsWorkFlow.Application,'jsWorkFlow.Application'));jsWorkFlow.Instance=function jsWorkFlow_Instance(){var log=jwf$getLogger();log.debug("Instance create!");this._events=new jsWorkFlow.Events(this);};function jsWorkFlow_Instance$dispose(){var log=jwf$getLogger();log.debug("Instance dispose!");if(this._rootActivity){this._rootActivity.dispose();this._rootActivity=null;}
this._events.dispose();this._events=null;}
function jsWorkFlow_Instance$get_rootActivity(){return this._rootActivity;}
function jsWorkFlow_Instance$set_rootActivity(value){this._rootActivity=value;}
function jsWorkFlow_Instance$loadFromXML(xml){}
function jsWorkFlow_Instance$unload(){}
function jsWorkFlow_Instance$execute(application){var log=jwf$getLogger();log.debug("Instance execute!");var activityExecutor=new jsWorkFlow.ActivityExecutor(application,this._rootActivity,null);this._initEventHandler=jso.createDelegate(this,this.initEventHandler);this._completeEventHandler=jso.createDelegate(this,this.completeEventHandler);activityExecutor.add_init(this._initEventHandler);activityExecutor.add_complete(this._completeEventHandler);activityExecutor.execute();}
function jsWorkFlow_Instance$doInit(eventArgs){var log=jwf$getLogger();log.debug("Instance doInit!");}
function jsWorkFlow_Instance$doComplete(eventArgs){var log=jwf$getLogger();log.debug("Instance doComplete!");}
function jsWorkFlow_Instance$initEventHandler(eventArgs){var log=jwf$getLogger();log.debug("Instance initEventHandler!");this.doInit(eventArgs);this._events.raiseEvent('init',eventArgs);}
function jsWorkFlow_Instance$add_init(handler){this._events.addHandler('init',handler);}
function jsWorkFlow_Instance$remove_init(handler){this._events.removeHandler('init',handler);}
function jsWorkFlow_Instance$completeEventHandler(eventArgs){var log=jwf$getLogger();log.debug("Instance completeEventHandler!");this._events.raiseEvent('complete',eventArgs);this.doComplete(eventArgs);}
function jsWorkFlow_Instance$add_complete(handler){this._events.addHandler('complete',handler);}
function jsWorkFlow_Instance$remove_complete(handler){this._events.removeHandler('complete',handler);}
jsWorkFlow.Instance.prototype={_rootActivity:null,_events:null,_initEventHandler:null,_completeEventHandler:null,dispose:jsWorkFlow_Instance$dispose,get_rootActivity:jsWorkFlow_Instance$get_rootActivity,set_rootActivity:jsWorkFlow_Instance$set_rootActivity,loadFromXML:jsWorkFlow_Instance$loadFromXML,unload:jsWorkFlow_Instance$unload,execute:jsWorkFlow_Instance$execute,doInit:jsWorkFlow_Instance$doInit,doComplete:jsWorkFlow_Instance$doComplete,initEventHandler:jsWorkFlow_Instance$initEventHandler,add_init:jsWorkFlow_Instance$add_init,remove_init:jsWorkFlow_Instance$remove_init,completeEventHandler:jsWorkFlow_Instance$completeEventHandler,add_complete:jsWorkFlow_Instance$add_complete,remove_complete:jsWorkFlow_Instance$remove_complete};jso.registerClass(jso.setTypeName(jsWorkFlow.Instance,'jsWorkFlow.Instance'));jsWorkFlow.ActivityEventArgs=function jsWorkFlow_ActivityEventArgs(context,data){jso.initializeBase(jsWorkFlow.ActivityEventArgs,this,[]);this._context=context;this._data=data;};function jsWorkFlow_ActivityEventArgs$dispose(){this._context=null;}
function jsWorkFlow_ActivityEventArgs$get_context(){return this._context;}
function jsWorkFlow_ActivityEventArgs$get_data(){return this._data;}
jsWorkFlow.ActivityEventArgs.prototype={_context:null,_data:null,dispose:jsWorkFlow_ActivityEventArgs$dispose,get_context:jsWorkFlow_ActivityEventArgs$get_context,get_data:jsWorkFlow_ActivityEventArgs$get_data};jso.registerClass(jso.setTypeName(jsWorkFlow.ActivityEventArgs,'jsWorkFlow.ActivityEventArgs'),jso.EventArgs);jsWorkFlow.ActivityHelper=function jsWorkFlow_ActivityHelper(){throw jso.errorNotImplemented();};jsWorkFlow.ActivityHelper.prototype={};jsWorkFlow.ActivityHelper.startActivity=function jsWorkFlow_ActivityHelper$startActivity(context){context.set_activityState(jsWorkFlow.ActivityState.start);}
jsWorkFlow.ActivityHelper.endActivity=function jsWorkFlow_ActivityHelper$endActivity(context){context.set_activityState(jsWorkFlow.ActivityState.end);}
jsWorkFlow.ActivityHelper.raiseError=function jsWorkFlow_ActivityHelper$raiseError(context,exception){var errorInfo=new jsWorkFlow.ActivityErrorInfo(context,exception);context.set_errorInfo(errorInfo);context.set_activityState(jsWorkFlow.ActivityState.error);}
jsWorkFlow.ActivityHelper._deliverError=function jsWorkFlow_ActivityHelper$_deliverError(activityContext){if(activityContext.get_activityState()!==jsWorkFlow.ActivityState.error){return;}
var errorInfo=activityContext.get_errorInfo();var parentContext=activityContext.get_parentContext();if(parentContext){parentContext.set_errorInfo(errorInfo);parentContext.set_activityState(jsWorkFlow.ActivityState.error);}}
jsWorkFlow.ActivityHelper._recoverError=function jsWorkFlow_ActivityHelper$_recoverError(activityContext,activityState){if(activityContext.get_activityState()!==jsWorkFlow.ActivityState.error){return;}
activityContext.set_errorInfo(null);activityContext.set_activityState(activityState);}
jsWorkFlow.ActivityHelper._getErrorInfo=function jsWorkFlow_ActivityHelper$_getErrorInfo(activityContext){var errorInfo=null;while(activityContext){if(activityContext.get_activityState()!==jsWorkFlow.ActivityState.error){activityContext=activityContext.get_parentContext();continue;}
errorInfo=activityContext.get_errorInfo();break;}
return errorInfo;}
jsWorkFlow.ActivityHelper.getLocalDataItem=function jsWorkFlow_ActivityHelper$getLocalDataItem(context,key){var retval=context.getDataItem();return retval;}
jsWorkFlow.ActivityHelper.getLocalData=function jsWorkFlow_ActivityHelper$getLocalData(context,key){var retval=context.getData(key);return retval;}
jsWorkFlow.ActivityHelper.setLocalData=function jsWorkFlow_ActivityHelper$setLocalData(context,key,value){context.setData(key,value);}
jsWorkFlow.ActivityHelper.getDataItem=function jsWorkFlow_ActivityHelper$getDataItem(context,key){var retval=jsWorkFlow.ActivityHelper.getLocalDataItem(context,key);if(retval){return retval;}
var app=context.get_application();retval=app.getDataItem();return retval;}
jsWorkFlow.ActivityHelper.getData=function jsWorkFlow_ActivityHelper$getData(context,key){var dataItem=jsWorkFlow.ActivityHelper.getDataItem(context,key);var retval=null;if(dataItem){retval=dataItem.value;}
return retval;}
jsWorkFlow.ActivityHelper.setData=function jsWorkFlow_ActivityHelper$setData(context,key,value){var dataItem=jsWorkFlow.ActivityHelper.getDataItem(context,key);if(dataItem){dataItem.value=value;return;}
context.setData(key,value);}
jsWorkFlow.ActivityHelper.getAppDataItem=function jsWorkFlow_ActivityHelper$getAppDataItem(context,key){var app=context.get_application();var appContext=app.get_appContext();var retval=appContext.getDataItem();return retval;}
jsWorkFlow.ActivityHelper.getAppData=function jsWorkFlow_ActivityHelper$getAppData(context,key){var dataItem=jsWorkFlow.ActivityHelper.getAppDataItem(context,key);var retval=null;if(dataItem){retval=dataItem.value;}
return retval;}
jsWorkFlow.ActivityHelper.setAppData=function jsWorkFlow_ActivityHelper$setAppData(context,key,value){var app=context.get_application();var appContext=app.get_appContext();appContext.setData(key,value);}
jsWorkFlow.ActivityHelper.getGlobalDataItem=function jsWorkFlow_ActivityHelper$getGlobalDataItem(context,key){var app=context.get_application();var globalContext=app.get_globalContext();var retval=globalContext.getDataItem();return retval;}
jsWorkFlow.ActivityHelper.getGlobalData=function jsWorkFlow_ActivityHelper$getGlobalData(context,key){var dataItem=jsWorkFlow.ActivityHelper.getGlobalDataItem(context,key);var retval=null;if(dataItem){retval=dataItem.value;}
return retval;}
jsWorkFlow.ActivityHelper.setGlobalData=function jsWorkFlow_ActivityHelper$setGlobalData(context,key,value){var app=context.get_application();var globalContext=app.get_globalContext();globalContext.setData(key,value);}
jsWorkFlow.ActivityHelper.loadActivity=function jsWorkFlow_ActivityHelper$loadActivity(serializeContext){var activity=null;if(serializeContext){var activityType=jso.getType(serializeContext['_@_activityType']);activity=new activityType();activity.loadSerializeContext(serializeContext);}
return activity;}
jsWorkFlow.ActivityHelper.saveActivity=function jsWorkFlow_ActivityHelper$saveActivity(activity){var serializeContext=null;if(activity){serializeContext={};activity.saveSerializeContext(serializeContext);}
return serializeContext;}
jso.registerClass(jso.setTypeName(jsWorkFlow.ActivityHelper,'jsWorkFlow.ActivityHelper'));var $jwf=jsWorkFlow.ActivityHelper;jsWorkFlow.Activity=function jsWorkFlow_Activity(){var log=jwf$getLogger();log.debug("Activity create!");this._events=new jsWorkFlow.Events(this);};function jsWorkFlow_Activity$dispose(){var log=jwf$getLogger();log.debug("Activity dispose!");this._events.dispose();this._events=null;}
function jsWorkFlow_Activity$getType(){return Object.getType(this);}
function jsWorkFlow_Activity$get_name(){return this._name;}
function jsWorkFlow_Activity$set_name(value){this._name=value;}
function jsWorkFlow_Activity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("Activity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
this.set_name(serializeContext['name']);}
function jsWorkFlow_Activity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("Activity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activity';serializeContext['name']=this.get_name();}
function jsWorkFlow_Activity$execute(context){var log=jwf$getLogger();log.debug("Activity execute!");$jwf.startActivity(context);}
function jsWorkFlow_Activity$notifyStateChanged(context,oldState,curState){var log=jwf$getLogger();log.debug("Activity notifyStateChanged!");var data={oldState:oldState,curState:curState};var eventArgs=new jsWorkFlow.ActivityEventArgs(context,data);if(oldState===jsWorkFlow.ActivityState.error){if(curState!==jsWorkFlow.ActivityState.error){this._events.raiseEvent('errorRecovery',eventArgs);log.debug("Activity notifyStateChanged jsWorkFlow.ActivityState.start!");return;}}
if(curState==jsWorkFlow.ActivityState.start){log.debug("Activity notifyStateChanged jsWorkFlow.ActivityState.start!");this._events.raiseEvent('start',eventArgs);}
else if(curState==jsWorkFlow.ActivityState.end){log.debug("Activity notifyStateChanged jsWorkFlow.ActivityState.end!");this._events.raiseEvent('end',eventArgs);}
else if(curState==jsWorkFlow.ActivityState.error){this._events.raiseEvent('error',eventArgs);}}
function jsWorkFlow_Activity$add_start(handler){this._events.addHandler('start',handler);}
function jsWorkFlow_Activity$remove_start(handler){this._events.removeHandler('start',handler);}
function jsWorkFlow_Activity$add_end(handler){this._events.addHandler('end',handler);}
function jsWorkFlow_Activity$remove_end(handler){this._events.removeHandler('end',handler);}
function jsWorkFlow_Activity$add_error(handler){this._events.addHandler('error',handler);}
function jsWorkFlow_Activity$remove_error(handler){this._events.removeHandler('error',handler);}
function jsWorkFlow_Activity$add_errorRecovery(handler){this._events.addHandler('errorRecovery',handler);}
function jsWorkFlow_Activity$remove_errorRecovery(handler){this._events.removeHandler('errorRecovery',handler);}
jsWorkFlow.Activity.prototype={_name:null,_events:null,dispose:jsWorkFlow_Activity$dispose,get_name:jsWorkFlow_Activity$get_name,set_name:jsWorkFlow_Activity$set_name,loadSerializeContext:jsWorkFlow_Activity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activity$saveSerializeContext,execute:jsWorkFlow_Activity$execute,notifyStateChanged:jsWorkFlow_Activity$notifyStateChanged,add_start:jsWorkFlow_Activity$add_start,remove_start:jsWorkFlow_Activity$remove_start,add_end:jsWorkFlow_Activity$add_end,remove_end:jsWorkFlow_Activity$remove_end,add_error:jsWorkFlow_Activity$add_error,remove_error:jsWorkFlow_Activity$remove_error,add_errorRecovery:jsWorkFlow_Activity$add_errorRecovery,remove_errorRecovery:jsWorkFlow_Activity$remove_errorRecovery};jso.registerClass(jso.setTypeName(jsWorkFlow.Activity,'jsWorkFlow.Activity'));jsWorkFlow.ContextBase=function jsWorkFlow_ContextBase(defaultVisibilityIsPublic){this._defaultVisibilityIsPublic=!!defaultVisibilityIsPublic;this._data={};};function jsWorkFlow_ContextBase$dispose(){this._data=null;}
function jsWorkFlow_ContextBase$get_defaultVisibilityIsPublic(){return this._defaultVisibilityIsPublic;}
function jsWorkFlow_ContextBase$clear(){this._data={};}
function jsWorkFlow_ContextBase$containKey(key){return this._data.hasOwnProperty(key);}
function jsWorkFlow_ContextBase$getDataItem(key){var item=null;if(this._data.hasOwnProperty(key)){item=this._data[key];}
return item;}
function jsWorkFlow_ContextBase$getData(key){var retval=null;var item=this.getDataItem(key);if(item){retval=item.value;}
return retval;}
function jsWorkFlow_ContextBase$setData(key,value,visibilitySwitch){var isPublic=(!!visibilitySwitch)?!this._defaultVisibilityIsPublic:this._defaultVisibilityIsPublic;var item={key:key,value:value,isPublic:isPublic};this._data[key]=item;}
function jsWorkFlow_ContextBase$copyFrom(srcDict,deepClone){if(!srcDict)
return;for(var key in srcDict){if(!srcDict.hasOwnProperty(key)){continue;}
this._data[key]=srcDict[key];}}
jsWorkFlow.ContextBase.prototype={_defaultVisibilityIsPublic:false,_data:null,dispose:jsWorkFlow_ContextBase$dispose,get_defaultVisibilityIsPublic:jsWorkFlow_ContextBase$get_defaultVisibilityIsPublic,clear:jsWorkFlow_ContextBase$clear,containKey:jsWorkFlow_ContextBase$containKey,getDataItem:jsWorkFlow_ContextBase$getDataItem,getData:jsWorkFlow_ContextBase$getData,setData:jsWorkFlow_ContextBase$setData,copyFrom:jsWorkFlow_ContextBase$copyFrom};jso.registerClass(jso.setTypeName(jsWorkFlow.ContextBase,'jsWorkFlow.ContextBase'));jsWorkFlow.GlobalContext=function jsWorkFlow_GlobalContext(){jso.initializeBase(jsWorkFlow.GlobalContext,this,[true]);};function jsWorkFlow_GlobalContext$dispose(){jso.callBaseMethod(jsWorkFlow.GlobalContext,this,'dispose');}
jsWorkFlow.GlobalContext.prototype={dispose:jsWorkFlow_GlobalContext$dispose};jso.registerClass(jso.setTypeName(jsWorkFlow.GlobalContext,'jsWorkFlow.GlobalContext'),jsWorkFlow.ContextBase);jsWorkFlow.GlobalContext._instance=new jsWorkFlow.GlobalContext();jsWorkFlow.GlobalContext.getInstance=function jsWorkFlow_GlobalContext$getInstance(){return jsWorkFlow.GlobalContext._instance;};jsWorkFlow.ApplicationContext=function jsWorkFlow_ApplicationContext(){jso.initializeBase(jsWorkFlow.ApplicationContext,this,[true]);};function jsWorkFlow_ApplicationContext$dispose(){jso.callBaseMethod(jsWorkFlow.ApplicationContext,this,'dispose');}
jsWorkFlow.ApplicationContext.prototype={dispose:jsWorkFlow_ApplicationContext$dispose};jso.registerClass(jso.setTypeName(jsWorkFlow.ApplicationContext,'jsWorkFlow.ApplicationContext'),jsWorkFlow.ContextBase);jsWorkFlow.ActivityErrorInfo=function jsWorkFlow_ActivityErrorInfo(originalContext,exception){this._originalContext=originalContext;this._exception=exception;}
function jsWorkFlow_ActivityErrorInfo$get_originalContext(){return this._originalContext;}
function jsWorkFlow_ActivityErrorInfo$get_exception(){return this._exception;}
jsWorkFlow.ActivityErrorInfo.prototype={_originalContext:null,_exception:null,get_originalContext:jsWorkFlow_ActivityErrorInfo$get_originalContext,get_exception:jsWorkFlow_ActivityErrorInfo$get_exception};jso.registerClass(jso.setTypeName(jsWorkFlow.ActivityErrorInfo,'jsWorkFlow.ActivityErrorInfo'));jsWorkFlow.ActivityContext=function jsWorkFlow_ActivityContext(application,activity,executor){jso.initializeBase(jsWorkFlow.ActivityContext,this);this._application=application;this._executor=executor;this._activity=activity;this._activityState=jsWorkFlow.ActivityState.none;this._args={};this._result=null;};function jsWorkFlow_ActivityContext$dispose(){this._application=null;this._executor=null;this._activity=null;this._args=null;this._result=null;jso.callBaseMethod(jsWorkFlow.ActivityContext,this,'dispose');}
function jsWorkFlow_ActivityContext$getParam(name){return this._args[name];}
function jsWorkFlow_ActivityContext$isError(){return!!this._errorInfo}
function jsWorkFlow_ActivityContext$get_application(){return this._application;}
function jsWorkFlow_ActivityContext$get_activity(){return this._activity;}
function jsWorkFlow_ActivityContext$get_executor(){return this._executor;}
function jsWorkFlow_ActivityContext$get_parentContext(){var parentContext=null;var executor=this.get_executor();if(executor){parentContext=executor.get_parentContext();}
return parentContext;}
function jsWorkFlow_ActivityContext$get_activityState(){return this._activityState;}
function jsWorkFlow_ActivityContext$set_activityState(value){var oldState=this._activityState;var curState=value;if((oldState==value)&&(value!==jsWorkFlow.ActivityState.error)){return;}
this._activityState=value;var data={oldState:oldState,curState:curState};var eventArgs=new jsWorkFlow.ActivityEventArgs(this,data);this._activity.notifyStateChanged(this,oldState,value);if(value==jsWorkFlow.ActivityState.end){this._executor.raiseCompleteEvent(eventArgs);}
if(value==jsWorkFlow.ActivityState.error){this._executor.processRuntimeError(eventArgs);}}
function jsWorkFlow_ActivityContext$get_result(){return this._result;}
function jsWorkFlow_ActivityContext$set_result(value){this._result=value;}
function jsWorkFlow_ActivityContext$get_errorInfo(){return this._errorInfo;}
function jsWorkFlow_ActivityContext$set_errorInfo(value){this._errorInfo=value;}
jsWorkFlow.ActivityContext.prototype={_application:null,_activity:null,_executor:null,_activityState:jsWorkFlow.ActivityState.none,_args:null,_result:null,_errorInfo:null,dispose:jsWorkFlow_ActivityContext$dispose,getParam:jsWorkFlow_ActivityContext$getParam,isError:jsWorkFlow_ActivityContext$isError,get_application:jsWorkFlow_ActivityContext$get_application,get_activity:jsWorkFlow_ActivityContext$get_activity,get_executor:jsWorkFlow_ActivityContext$get_executor,get_parentContext:jsWorkFlow_ActivityContext$get_parentContext,get_activityState:jsWorkFlow_ActivityContext$get_activityState,set_activityState:jsWorkFlow_ActivityContext$set_activityState,get_result:jsWorkFlow_ActivityContext$get_result,set_result:jsWorkFlow_ActivityContext$set_result,get_errorInfo:jsWorkFlow_ActivityContext$get_errorInfo,set_errorInfo:jsWorkFlow_ActivityContext$set_errorInfo};jso.registerClass(jso.setTypeName(jsWorkFlow.ActivityContext,'jsWorkFlow.ActivityContext'),jsWorkFlow.ContextBase);jsWorkFlow.ActivityExecutor=function jsWorkFlow_ActivityExecutor(application,activity,parentContext){var log=jwf$getLogger();log.debug("ActivityExecutor create!");this._application=application;this._activity=activity;this._activityContext=null;this._parentContext=parentContext;this._events=new jsWorkFlow.Events(this);};function jsWorkFlow_ActivityExecutor$dispose(){var log=jwf$getLogger();log.debug("ActivityExecutor dispose!");this._activityContext.dispose();this._events.dispose();this._application=null;this._activity=null;this._activityContext=null;this._events=null;this._deliverError=true;}
function jsWorkFlow_ActivityExecutor$get_activityContext(){return this._activityContext;}
function jsWorkFlow_ActivityExecutor$get_parentContext(){return this._parentContext;}
function jsWorkFlow_ActivityExecutor$get_deliverError(){return this._deliverError;}
function jsWorkFlow_ActivityExecutor$set_deliverError(value){this._deliverError=!!value;}
function _jwf$ae$run_and_check(activityContext,callback,callbackContext){var activityExecutor=activityContext.get_executor();try{callback(callbackContext);}catch(e){activityExecutor.doCatchException(e);}}
function jsWorkFlow_ActivityExecutor$doJobCallback(jobItem){var log=jwf$getLogger();log.debug("ActivityExecutor doJobCallback!");var activityExecutor=this;var activity=this._activity;var application=this._application;var activityContext=this._activityContext;jsWorkFlow.ActivityExecutor.run_and_check(this._activityContext,function(){var eventArgs=new jsWorkFlow.ActivityEventArgs(activityContext);activityExecutor.raiseInitEvent(eventArgs);activity.execute(activityContext);},null);}
function jsWorkFlow_ActivityExecutor$execute(){var log=jwf$getLogger();log.debug("ActivityExecutor execute!");var activityExecutor=this;var activity=this._activity;var application=this._application;var activityContext=this._activityContext;this._activityContext=new jsWorkFlow.ActivityContext(application,activity,this);var callback=jso.createDelegate(this,this.doJobCallback);var scheduler=this._application.get_scheduler();var job=new jsWorkFlow.Job(callback,null);scheduler.scheduleJob(job);}
function jsWorkFlow_ActivityExecutor$doInit(eventArgs){var log=jwf$getLogger();log.debug("ActivityExecutor doInit!");this._application.pushContextStack(this._activityContext);}
function jsWorkFlow_ActivityExecutor$doComplete(eventArgs){var log=jwf$getLogger();log.debug("ActivityExecutor doComplete!");this._application.popContextStack();}
function jsWorkFlow_ActivityExecutor$doCatchException(exception){var log=jwf$getLogger();log.info("ActivityExecutor doCatchException!",exception);var activityContext=this._activityContext;$jwf.raiseError(activityContext,exception);}
function jsWorkFlow_ActivityExecutor$processRuntimeError(eventArgs){var log=jwf$getLogger();log.debug("ActivityExecutor processRuntimeError!");var activityContext=this._activityContext;var data=eventArgs.get_data();var oldState=data.oldState;var curState=data.curState;this._events.raiseEvent('error',eventArgs);if(activityContext.get_activityState()===jsWorkFlow.ActivityState.error){if(this.get_deliverError()||(oldState===jsWorkFlow.ActivityState.error)){$jwf._deliverError(activityContext);}}
this._events.raiseEvent('errorComplete',eventArgs);}
function jsWorkFlow_ActivityExecutor$doErrorRecovery(activityState){var log=jwf$getLogger();log.debug("ActivityExecutor doErrorRecovery!");var activityContext=this._activityContext;if(activityContext.get_activityState()!==jsWorkFlow.ActivityState.error){log.error("activityState is not [jsWorkFlow.ActivityState.error]!");return;}
$jwf._recoverError(activityContext,activityState);}
function jsWorkFlow_ActivityExecutor$raiseInitEvent(eventArgs){var log=jwf$getLogger();log.debug("ActivityExecutor raiseInitEvent!");this._events.raiseEvent('preInit',eventArgs);this.doInit(eventArgs);this._events.raiseEvent('init',eventArgs);}
function jsWorkFlow_ActivityExecutor$raiseCompleteEvent(eventArgs){var log=jwf$getLogger();log.debug("ActivityExecutor raiseCompleteEvent!");this._events.raiseEvent('complete',eventArgs);this.doComplete(eventArgs);this._events.raiseEvent('postComplete',eventArgs);}
function jsWorkFlow_ActivityExecutor$add_preInit(handler){this._events.addHandler('preInit',handler);}
function jsWorkFlow_ActivityExecutor$remove_preInit(handler){this._events.removeHandler('preInit',handler);}
function jsWorkFlow_ActivityExecutor$add_init(handler){this._events.addHandler('init',handler);}
function jsWorkFlow_ActivityExecutor$remove_init(handler){this._events.removeHandler('init',handler);}
function jsWorkFlow_ActivityExecutor$add_complete(handler){this._events.addHandler('complete',handler);}
function jsWorkFlow_ActivityExecutor$remove_complete(handler){this._events.removeHandler('complete',handler);}
function jsWorkFlow_ActivityExecutor$add_postComplete(handler){this._events.addHandler('postComplete',handler);}
function jsWorkFlow_ActivityExecutor$remove_postComplete(handler){this._events.removeHandler('postComplete',handler);}
function jsWorkFlow_ActivityExecutor$add_error(handler){this._events.addHandler('error',handler);}
function jsWorkFlow_ActivityExecutor$remove_error(handler){this._events.removeHandler('error',handler);}
function jsWorkFlow_ActivityExecutor$add_errorComplete(handler){this._events.addHandler('errorComplete',handler);}
function jsWorkFlow_ActivityExecutor$remove_errorComplete(handler){this._events.removeHandler('errorComplete',handler);}
jsWorkFlow.ActivityExecutor.prototype={_application:null,_activity:null,_activityContext:null,_parentContext:null,_events:null,_deliverError:true,dispose:jsWorkFlow_ActivityExecutor$dispose,get_activityContext:jsWorkFlow_ActivityExecutor$get_activityContext,get_parentContext:jsWorkFlow_ActivityExecutor$get_parentContext,get_deliverError:jsWorkFlow_ActivityExecutor$get_deliverError,set_deliverError:jsWorkFlow_ActivityExecutor$set_deliverError,doJobCallback:jsWorkFlow_ActivityExecutor$doJobCallback,execute:jsWorkFlow_ActivityExecutor$execute,doInit:jsWorkFlow_ActivityExecutor$doInit,doComplete:jsWorkFlow_ActivityExecutor$doComplete,doCatchException:jsWorkFlow_ActivityExecutor$doCatchException,processRuntimeError:jsWorkFlow_ActivityExecutor$processRuntimeError,doErrorRecovery:jsWorkFlow_ActivityExecutor$doErrorRecovery,raiseInitEvent:jsWorkFlow_ActivityExecutor$raiseInitEvent,raiseCompleteEvent:jsWorkFlow_ActivityExecutor$raiseCompleteEvent,add_preInit:jsWorkFlow_ActivityExecutor$add_preInit,remove_preInit:jsWorkFlow_ActivityExecutor$remove_preInit,add_init:jsWorkFlow_ActivityExecutor$add_init,remove_init:jsWorkFlow_ActivityExecutor$remove_init,add_complete:jsWorkFlow_ActivityExecutor$add_complete,remove_complete:jsWorkFlow_ActivityExecutor$remove_complete,add_postComplete:jsWorkFlow_ActivityExecutor$add_postComplete,remove_postComplete:jsWorkFlow_ActivityExecutor$remove_postComplete,add_error:jsWorkFlow_ActivityExecutor$add_error,remove_error:jsWorkFlow_ActivityExecutor$remove_error,add_errorComplete:jsWorkFlow_ActivityExecutor$add_errorComplete,remove_errorComplete:jsWorkFlow_ActivityExecutor$remove_errorComplete};jsWorkFlow.ActivityExecutor.run_and_check=_jwf$ae$run_and_check;jso.registerClass(jso.setTypeName(jsWorkFlow.ActivityExecutor,'jsWorkFlow.ActivityExecutor'));jsWorkFlow.Job=function jsWorkFlow_Job(callback,context){this._callback=callback;this._context=context;};function jsWorkFlow_Job$dispose(){}
function jsWorkFlow_Job$get_context(){return this._context;}
function jsWorkFlow_Job$get_result(){return this._result;}
function jsWorkFlow_Job$set_result(value){this._result=value;}
function jsWorkFlow_Job$execute(){if(this._callback){this._callback(this);}}
jsWorkFlow.Job.prototype={_callback:null,_context:null,_result:null,dispose:jsWorkFlow_Job$dispose,get_context:jsWorkFlow_Job$get_context,get_result:jsWorkFlow_Job$get_result,set_result:jsWorkFlow_Job$set_result,execute:jsWorkFlow_Job$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Job,'jsWorkFlow.Job'));jsWorkFlow.Scheduler=function jsWorkFlow_Scheduler(){var log=jwf$getLogger();log.debug("Scheduler create!");this._events=new jsWorkFlow.Events(this);};jsWorkFlow.Scheduler.interval_timer=10;jsWorkFlow.Scheduler.interval_time_bar=100;function jsWorkFlow_Scheduler$get_isRunning(){return this._isRunning;}
function jsWorkFlow_Scheduler$get_isStopPending(){return this._isStopPending;}
function jsWorkFlow_Scheduler$get_isPausing(){return this._isPausing;}
function jsWorkFlow_Scheduler$dispose(){var log=jwf$getLogger();log.debug("Scheduler dispose!");if(this._isRunning){this.stop(true);}
this._events.dispose();this._events=null;}
function jsWorkFlow_Scheduler$scheduleJob(job){jso.arrayAdd(this._jobQueue,job);}
function jsWorkFlow_Scheduler$doExecJobInterval(){if(!this._isRunning){return;}
if(this._isPausing){return;}
var jobQueue=this._jobQueue;var startTime=(new Date()).getTime();for(var i=0,ilen=jobQueue.length;i<ilen;i++){var job=jobQueue.shift();try{job.execute();job.dispose();}catch(e){var log=jwf$getLogger();log.error("Scheduler catch exception in doExecJobInterval!",e);}
var curTime=(new Date()).getTime();if((curTime-startTime)>jsWorkFlow.Scheduler.interval_time_bar){break;}}
if(this._isStopPending){if(jobQueue.length==0){this.stop(true);}}}
function jsWorkFlow_Scheduler$start(isPausing){var log=jwf$getLogger();log.debug("Scheduler start!");if(this._isRunning){throw jso.errorInvalidOperation("Scheduler is already running!");}
var handler=jso.createDelegate(this,this.doExecJobInterval);this._intervalID=jsWorkFlow.setInterval(handler,jsWorkFlow.Scheduler.interval_timer);this._isRunning=true;this._isStopPending=false;this._isPausing=!!isPausing;this._jobQueue=[];this._events.raiseEvent('start',jso.EventArgs.Empty);}
function jsWorkFlow_Scheduler$pause(){var log=jwf$getLogger();log.debug("Scheduler pause!");if(!this._isRunning||this._isStopPending){throw jso.errorInvalidOperation("Scheduler is not running!");return;}
this._isPausing=true;this._events.raiseEvent('pause',jso.EventArgs.Empty);}
function jsWorkFlow_Scheduler$resume(){var log=jwf$getLogger();log.debug("Scheduler resume!");if(!this._isRunning||this._isStopPending){throw jso.errorInvalidOperation("Scheduler is not running!");}
this._isPausing=false;this._events.raiseEvent('resume',jso.EventArgs.Empty);}
function jsWorkFlow_Scheduler$stop(forceStopNow){var log=jwf$getLogger();log.debug("Scheduler stop!");if(!this._isRunning){throw jso.errorInvalidOperation("Scheduler is not running!");return;}
if(!forceStopNow){if(this._isPausing){throw jso.errorInvalidOperation("Scheduler is pausing, can't put into stoppending state! please resume it first.");return;}
this._isStopPending=true;return;}
this.forceStop();}
function jsWorkFlow_Scheduler$forceStop(){var log=jwf$getLogger();log.debug("Scheduler forceStop!");var jobQueue=this._jobQueue;for(var i=0,ilen=jobQueue.length;i<ilen;i++){var job=jobQueue.shift();try{job.dispose();}catch(e){log.error("app catch exception in forceStop!",e);}}
this._isRunning=false;jsWorkFlow.clearInterval(this._intervalID);this._intervalID=-1;this._events.raiseEvent('stop',jso.EventArgs.Empty);}
function jsWorkFlow_Scheduler$add_start(handler){this._events.addHandler('start',handler);}
function jsWorkFlow_Scheduler$remove_start(handler){this._events.removeHandler('start',handler);}
function jsWorkFlow_Scheduler$add_pause(handler){this._events.addHandler('pause',handler);}
function jsWorkFlow_Scheduler$remove_pause(handler){this._events.removeHandler('pause',handler);}
function jsWorkFlow_Scheduler$add_resume(handler){this._events.addHandler('resume',handler);}
function jsWorkFlow_Scheduler$remove_resume(handler){this._events.removeHandler('resume',handler);}
function jsWorkFlow_Scheduler$add_stop(handler){this._events.addHandler('stop',handler);}
function jsWorkFlow_Scheduler$remove_stop(handler){this._events.removeHandler('stop',handler);}
jsWorkFlow.Scheduler.prototype={_events:null,_isRunning:false,_isStopPending:false,_isPausing:false,_jobQueue:null,_intervalID:-1,get_isRunning:jsWorkFlow_Scheduler$get_isRunning,get_isStopPending:jsWorkFlow_Scheduler$get_isStopPending,get_isPausing:jsWorkFlow_Scheduler$get_isPausing,dispose:jsWorkFlow_Scheduler$dispose,scheduleJob:jsWorkFlow_Scheduler$scheduleJob,doExecJobInterval:jsWorkFlow_Scheduler$doExecJobInterval,start:jsWorkFlow_Scheduler$start,pause:jsWorkFlow_Scheduler$pause,resume:jsWorkFlow_Scheduler$resume,stop:jsWorkFlow_Scheduler$stop,forceStop:jsWorkFlow_Scheduler$forceStop,add_start:jsWorkFlow_Scheduler$add_start,remove_start:jsWorkFlow_Scheduler$remove_start,add_pause:jsWorkFlow_Scheduler$add_pause,remove_pause:jsWorkFlow_Scheduler$remove_pause,add_resume:jsWorkFlow_Scheduler$add_resume,remove_resume:jsWorkFlow_Scheduler$remove_resume,add_stop:jsWorkFlow_Scheduler$add_stop,remove_stop:jsWorkFlow_Scheduler$remove_stop};jso.registerClass(jso.setTypeName(jsWorkFlow.Scheduler,'jsWorkFlow.Scheduler'));

var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.ActivityFactory=function jsWorkFlow_ActivityFactory(){this._templates={};this._registry={};};function jsWorkFlow_ActivityFactory$dispose(){this._templates={};this._registry={};}
function _jsw_af$verifyTemplate(jsDoc){if(!jsDoc){throw jso.errorInvalidOperation("invalid template");}
if(!jsDoc["id"]||!jsDoc["type"]){throw jso.errorInvalidOperation("invalid template");}}
function jsWorkFlow_ActivityFactory$registerTemplate(jsDoc){if(!jsDoc){throw jso.errorArgument("jsDoc","undefined");}
if(!jso.isArray(jsDoc)){jsDoc=[jsDoc];}
for(var i=0,ilen=jsDoc.length;i<ilen;i++){var curDoc=jsDoc[i];_jsw_af$verifyTemplate(curDoc);this._templates[curDoc.id]=curDoc;}}
function jsWorkFlow_ActivityFactory$getTemplate(id){return this._templates[id];}
function jsWorkFlow_ActivityFactory$clearTemplates(){this._templates={};}
function jsWorkFlow_ActivityFactory$registerObject(id,obj){this._registry[id]=obj;}
function jsWorkFlow_ActivityFactory$clearObjects(){this._registry={};}
function jsWorkFlow_ActivityFactory$tryGetObject(id){var obj=this._registry[id];if(!obj){obj=this.tryCreateObject(id);if(obj){this._registry[id]=obj;}}
return obj;}
function jsWorkFlow_ActivityFactory$getObject(id){var obj=this._registry[id];if(!obj){obj=this.createObject(id);if(obj){this._registry[id]=obj;}}
return obj;}
function _jsw_af$createValueByDesc(valueDesc,objFactory){var retval=null;if(valueDesc.ref){retval=objFactory.getObject(valueDesc.ref);}
else if(valueDesc.val){retval=valueDesc.val;}
return retval;}
function _jsw_af$createValue(valueDesc,objFactory,strict){var retval=null;if(!valueDesc){return retval;}
if(jso.isArray(valueDesc)){retval=[];for(var i=0,ilen=valueDesc.length;i<ilen;i++){var curValDesc=valueDesc[i];var curVal=_jsw_af$createValue(curValDesc,objFactory,strict);jso.arrayAdd(retval,curVal);}}else if(jso.isPureObject(valueDesc)){if(!!valueDesc['__v']){retval=_jsw_af$createValueByDesc(valueDesc,objFactory);}
else{retval={};for(var key in valueDesc){if(key==='__v'){continue;}
var curValDesc=valueDesc[key];var curVal=_jsw_af$createValue(curValDesc,objFactory,strict);retval[key]=curVal;}}}else{if(jso.isString(valueDesc)&&!strict){var obj=objFactory.tryGetObject(valueDesc);if(obj){retval=obj;}
else{retval=valueDesc;}}
else{retval=valueDesc;}}
return retval;}
function _jsw_af$applyProperties(ins,props){for(var prop in props){var setProp="set_"+prop;var method=ins[setProp];var propValue=props[prop];if(!method){throw jso.errorNotExists("property:["+setProp+"]");}
method.apply(ins,[propValue]);}}
function _jsw_af$createObject(jsDoc,objFactory){var typeName=jsDoc['type'];var strict=!!jsDoc['strict'];var constructorsDesc=jsDoc['constructors'];var propertiesDesc=jsDoc['properties'];var type=jso.getType(typeName);if(!type){throw jso.errorNotExists("type:["+typeName+"]");}
var constrctors=_jsw_af$createValue(constructorsDesc,objFactory,strict);var properties={};for(var key in propertiesDesc){var curPropValueDesc=propertiesDesc[key];var curPropValue=_jsw_af$createValue(curPropValueDesc,objFactory,strict);properties[key]=curPropValue;}
var instance=jso.createInstance(type,constrctors);_jsw_af$applyProperties(instance,properties);return instance;}
function jsWorkFlow_ActivityFactory$tryCreateObject(id){var jsDoc=this.getTemplate(id);if(!jsDoc){return null;}
var obj=_jsw_af$createObject(jsDoc,this);return obj;}
function jsWorkFlow_ActivityFactory$createObject(id){var jsDoc=this.getTemplate(id);if(!jsDoc){throw jso.errorNotExists("id:["+id+"]");}
var obj=_jsw_af$createObject(jsDoc,this);return obj;}
jsWorkFlow.ActivityFactory.prototype={_templates:null,_registry:null,dispose:jsWorkFlow_ActivityFactory$dispose,registerTemplate:jsWorkFlow_ActivityFactory$registerTemplate,getTemplate:jsWorkFlow_ActivityFactory$getTemplate,clearTemplates:jsWorkFlow_ActivityFactory$clearTemplates,registerObject:jsWorkFlow_ActivityFactory$registerObject,clearObjects:jsWorkFlow_ActivityFactory$clearObjects,tryGetObject:jsWorkFlow_ActivityFactory$tryGetObject,getObject:jsWorkFlow_ActivityFactory$getObject,tryCreateObject:jsWorkFlow_ActivityFactory$tryCreateObject,createObject:jsWorkFlow_ActivityFactory$createObject};jso.registerClass(jso.setTypeName(jsWorkFlow.ActivityFactory,'jsWorkFlow.ActivityFactory'));

var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.NullLogger=function jsWorkFlow_NullLogger(){};function jsWorkFlow_NullLogger$dummy(){}
jsWorkFlow.NullLogger.prototype={trace:jsWorkFlow_NullLogger$dummy,debug:jsWorkFlow_NullLogger$dummy,info:jsWorkFlow_NullLogger$dummy,warn:jsWorkFlow_NullLogger$dummy,error:jsWorkFlow_NullLogger$dummy,fatal:jsWorkFlow_NullLogger$dummy};jso.registerClass(jso.setTypeName(jsWorkFlow.NullLogger,'jsWorkFlow.NullLogger'));jsWorkFlow.ConsoleLogger=function jsWorkFlow_ConsoleLogger(){};function jsWorkFlow_ConsoleLogger$_log(level,message){console.log('['+level+']+%s',message);}
function jsWorkFlow_ConsoleLogger$trace(message){this._log('trace',message);}
function jsWorkFlow_ConsoleLogger$debug(message){this._log('debug',message);}
function jsWorkFlow_ConsoleLogger$info(message){this._log('info',message);}
function jsWorkFlow_ConsoleLogger$warn(message){this._log('warn',message);}
function jsWorkFlow_ConsoleLogger$error(message){this._log('error',message);}
function jsWorkFlow_ConsoleLogger$fatal(message){this._log('fatal',message);}
jsWorkFlow.ConsoleLogger.prototype={_log:jsWorkFlow_ConsoleLogger$_log,trace:jsWorkFlow_ConsoleLogger$trace,debug:jsWorkFlow_ConsoleLogger$debug,info:jsWorkFlow_ConsoleLogger$info,warn:jsWorkFlow_ConsoleLogger$warn,error:jsWorkFlow_ConsoleLogger$error,fatal:jsWorkFlow_ConsoleLogger$fatal};jso.registerClass(jso.setTypeName(jsWorkFlow.ConsoleLogger,'jsWorkFlow.ConsoleLogger'));var _jwf$logger=null;function _jwf$config_log(){var log=null;if(typeof(log4javascript)!=="undefined"){var log=log4javascript.getLogger();var popUpAppender=new log4javascript.PopUpAppender();var popUpLayout=new log4javascript.PatternLayout("%d{HH:mm:ss} %-5p - %m%n");popUpAppender.setLayout(popUpLayout);log.addAppender(popUpAppender);}
else{log=new jsWorkFlow.NullLogger();}
_jwf$logger=log;}
function jwf$getLogger(){return _jwf$logger;}
_jwf$config_log();

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.DelayActivity=function jsWorkFlow_Activities_DelayActivity(delayTime){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DelayActivity create!");jso.initializeBase(jsWorkFlow.Activities.DelayActivity,this);this._delayTime=delayTime;};function jsWorkFlow_Activities_DelayActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DelayActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.DelayActivity,this,'dispose');}
function jsWorkFlow_Activities_DelayActivity$get_delayTime(){return this._delayTime;}
function jsWorkFlow_Activities_DelayActivity$set_delayTime(value){this._delayTime=value;}
function jsWorkFlow_Activities_DelayActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DelayActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.DelayActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.DelayActivity,this,'loadSerializeContext',[baseSerializeContext]);this.set_delayTime(serializeContext['delayTime']);}
function jsWorkFlow_Activities_DelayActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DelayActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.DelayActivity';serializeContext['delayTime']=this.get_delayTime();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.DelayActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_DelayActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DelayActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.DelayActivity,this,'execute',[context]);context._timeoutID=jsWorkFlow.setTimeout(function(){$jwf.endActivity(context);jsWorkFlow.clearTimeout(context._timeoutID);},this._delayTime);}
jsWorkFlow.Activities.DelayActivity.prototype={_delayTime:null,dispose:jsWorkFlow_Activities_DelayActivity$dispose,get_delayTime:jsWorkFlow_Activities_DelayActivity$get_delayTime,set_delayTime:jsWorkFlow_Activities_DelayActivity$set_delayTime,loadSerializeContext:jsWorkFlow_Activities_DelayActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_DelayActivity$saveSerializeContext,execute:jsWorkFlow_Activities_DelayActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.DelayActivity,'jsWorkFlow.Activities.DelayActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.EvalExprActivity=function jsWorkFlow_Activities_EvalExprActivity(expr){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EvalExprActivity create!");jso.initializeBase(jsWorkFlow.Activities.EvalExprActivity,this);this.set_expr(expr);};function jsWorkFlow_Activities_EvalExprActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EvalExprActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.EvalExprActivity,this,'dispose');}
function jsWorkFlow_Activities_EvalExprActivity$get_expr(){return this._expr;}
function jsWorkFlow_Activities_EvalExprActivity$set_expr(value){if(typeof(value)==="string"){this._expr=value;}else{if((typeof(value)==="undefined")||(value===null)){this._expr="";}
else{throw jso.errorInvalidOperation();}}}
function jsWorkFlow_Activities_EvalExprActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EvalExprActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.EvalExprActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.EvalExprActivity,this,'loadSerializeContext',[baseSerializeContext]);this.set_expr(serializeContext['expr']);}
function jsWorkFlow_Activities_EvalExprActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EvalExprActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.EvalExprActivity';serializeContext['expr']=this.get_expr();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.EvalExprActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_EvalExprActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EvalExprActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.EvalExprActivity,this,'execute',[context]);if(this._expr.length>0){var result=eval(this._expr);context.set_result(result);}
$jwf.endActivity(context);}
jsWorkFlow.Activities.EvalExprActivity.prototype={_expr:null,dispose:jsWorkFlow_Activities_EvalExprActivity$dispose,get_expr:jsWorkFlow_Activities_EvalExprActivity$get_expr,set_expr:jsWorkFlow_Activities_EvalExprActivity$set_expr,loadSerializeContext:jsWorkFlow_Activities_EvalExprActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_EvalExprActivity$saveSerializeContext,execute:jsWorkFlow_Activities_EvalExprActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.EvalExprActivity,'jsWorkFlow.Activities.EvalExprActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.FunctionActivityEventArgs=function jsWorkFlow_Activities_FunctionActivityEventArgs(context,callbackData){jso.initializeBase(jsWorkFlow.Activities.FunctionActivityEventArgs,this,[context,callbackData]);};function jsWorkFlow_Activities_FunctionActivityEventArgs$dispose(){jso.callBaseMethod(jsWorkFlow.Activities.FunctionActivityEventArgs,this,'dispose');}
function jsWorkFlow_Activities_FunctionActivityEventArgs$get_callbackData(){return this.get_data();}
jsWorkFlow.Activities.FunctionActivityEventArgs.prototype={dispose:jsWorkFlow_Activities_FunctionActivityEventArgs$dispose,get_callbackData:jsWorkFlow_Activities_FunctionActivityEventArgs$get_callbackData};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.FunctionActivityEventArgs,'jsWorkFlow.Activities.FunctionActivityEventArgs'),jsWorkFlow.ActivityEventArgs);jsWorkFlow.Activities.FunctionActivity=function jsWorkFlow_Activities_FunctionActivity(func,callbackData){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.FunctionActivity create!");this._func=func;this._callbackData=callbackData;jso.initializeBase(jsWorkFlow.Activities.FunctionActivity,this);};function jsWorkFlow_Activities_FunctionActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.FunctionActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.FunctionActivity,this,'dispose');}
function jsWorkFlow_Activities_FunctionActivity$get_func(){return this._func;}
function jsWorkFlow_Activities_FunctionActivity$set_func(value){this._func=value;}
function jsWorkFlow_Activities_FunctionActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.FunctionActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.FunctionActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.FunctionActivity,this,'loadSerializeContext',[baseSerializeContext]);this.set_func(eval(serializeContext['func']));}
function jsWorkFlow_Activities_FunctionActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.FunctionActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.FunctionActivity';var func=this.get_func();var funcName="";if(func){var funcBody=func.toString();funcName=funcBody.substring(funcBody.indexOf("function")+8,funcBody.indexOf("("));}
serializeContext['func']=funcName;var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.FunctionActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_FunctionActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.FunctionActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.FunctionActivity,this,'execute',[context]);var eventArgs=new jsWorkFlow.Activities.FunctionActivityEventArgs(context,this._callbackData);var result=this._func(eventArgs);context.set_result(result);$jwf.endActivity(context);}
jsWorkFlow.Activities.FunctionActivity.prototype={_func:null,_callbackData:null,dispose:jsWorkFlow_Activities_FunctionActivity$dispose,get_func:jsWorkFlow_Activities_FunctionActivity$get_func,set_func:jsWorkFlow_Activities_FunctionActivity$set_func,loadSerializeContext:jsWorkFlow_Activities_FunctionActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_FunctionActivity$saveSerializeContext,execute:jsWorkFlow_Activities_FunctionActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.FunctionActivity,'jsWorkFlow.Activities.FunctionActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.IfElseActivity=function jsWorkFlow_Activities_IfElseActivity(conditionActivity,thenActivity,elseActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity create!");jso.initializeBase(jsWorkFlow.Activities.IfElseActivity,this);this.set_conditionActivity(conditionActivity);this.set_thenActivity(thenActivity);this.set_elseActivity(elseActivity);this._doEvalConditionCompleteHandler=jso.createDelegate(this,this.doEvalConditionCompleteHandler);this._doExecuteBodyCompleteHandler=jso.createDelegate(this,this.doExecuteBodyCompleteHandler);};function jsWorkFlow_Activities_IfElseActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity dispose!");this._conditionActivity=null;this._elseActivity=null;this._thenActivity=null;jso.callBaseMethod(jsWorkFlow.Activities.IfElseActivity,this,'dispose');}
function jsWorkFlow_Activities_IfElseActivity$get_conditionActivity(){return this._conditionActivity;}
function jsWorkFlow_Activities_IfElseActivity$set_conditionActivity(value){this._conditionActivity=value;}
function jsWorkFlow_Activities_IfElseActivity$get_thenActivity(){return this._thenActivity;}
function jsWorkFlow_Activities_IfElseActivity$set_thenActivity(value){this._thenActivity=value;}
function jsWorkFlow_Activities_IfElseActivity$get_elseActivity(){return this._elseActivity;}
function jsWorkFlow_Activities_IfElseActivity$set_elseActivity(value){this._elseActivity=value;}
function jsWorkFlow_Activities_IfElseActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.IfElseActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.IfElseActivity,this,'loadSerializeContext',[baseSerializeContext]);var conditionActivitySC=serializeContext['conditionActivity'];var conditionActivity=$jwf.loadActivity(conditionActivitySC);this.set_conditionActivity(conditionActivity);var thenActivitySC=serializeContext['thenActivity'];var thenActivity=$jwf.loadActivity(thenActivitySC);this.set_thenActivity(thenActivity);var elseActivitySC=serializeContext['elseActivity'];var elseActivity=$jwf.loadActivity(elseActivitySC);this.set_elseActivity(elseActivity);}
function jsWorkFlow_Activities_IfElseActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.IfElseActivity';serializeContext['conditionActivity']=$jwf.saveActivity(this.get_conditionActivity());serializeContext['thenActivity']=$jwf.saveActivity(this.get_thenActivity());serializeContext['elseActivity']=$jwf.saveActivity(this.get_elseActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.IfElseActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_IfElseActivity$doEvalCondition(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity doEvalCondition!");var activity=this._conditionActivity;if(!activity){this.doExecuteBody(context,false);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalConditionCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_IfElseActivity$doEvalConditionCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity doEvalConditionCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var condition=context.get_result();this.doExecuteBody(parentContext,condition);}
function jsWorkFlow_Activities_IfElseActivity$doExecuteBody(context,condition){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity doExecuteBody!");var activity=(condition)?this._thenActivity:this._elseActivity;log.debug("condition is:["+!!condition+"!");if(!activity){$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doExecuteBodyCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_IfElseActivity$doExecuteBodyCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity doExecuteBodyCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var result=context.get_result();parentContext.set_result(result);$jwf.endActivity(parentContext);return;}
function jsWorkFlow_Activities_IfElseActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.IfElseActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.IfElseActivity,this,'execute',[context]);this.doEvalCondition(context);}
jsWorkFlow.Activities.IfElseActivity.prototype={_conditionActivity:null,_thenActivity:null,_elseActivity:null,_doEvalConditionCompleteHandler:null,_doExecuteBodyCompleteHandler:null,dispose:jsWorkFlow_Activities_IfElseActivity$dispose,get_conditionActivity:jsWorkFlow_Activities_IfElseActivity$get_conditionActivity,set_conditionActivity:jsWorkFlow_Activities_IfElseActivity$set_conditionActivity,get_thenActivity:jsWorkFlow_Activities_IfElseActivity$get_thenActivity,set_thenActivity:jsWorkFlow_Activities_IfElseActivity$set_thenActivity,get_elseActivity:jsWorkFlow_Activities_IfElseActivity$get_elseActivity,set_elseActivity:jsWorkFlow_Activities_IfElseActivity$set_elseActivity,loadSerializeContext:jsWorkFlow_Activities_IfElseActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_IfElseActivity$saveSerializeContext,doEvalCondition:jsWorkFlow_Activities_IfElseActivity$doEvalCondition,doEvalConditionCompleteHandler:jsWorkFlow_Activities_IfElseActivity$doEvalConditionCompleteHandler,doExecuteBody:jsWorkFlow_Activities_IfElseActivity$doExecuteBody,doExecuteBodyCompleteHandler:jsWorkFlow_Activities_IfElseActivity$doExecuteBodyCompleteHandler,execute:jsWorkFlow_Activities_IfElseActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.IfElseActivity,'jsWorkFlow.Activities.IfElseActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.NoopActivity=function jsWorkFlow_Activities_NoopActivity(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.NoopActivity create!");jso.initializeBase(jsWorkFlow.Activities.NoopActivity,this);};function jsWorkFlow_Activities_NoopActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.NoopActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.NoopActivity,this,'dispose');}
function jsWorkFlow_Activities_NoopActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.NoopActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.NoopActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.NoopActivity,this,'loadSerializeContext',[baseSerializeContext]);}
function jsWorkFlow_Activities_NoopActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.NoopActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.NoopActivity';var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.NoopActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_NoopActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.NoopActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.NoopActivity,this,'execute',[context]);$jwf.endActivity(context);}
jsWorkFlow.Activities.NoopActivity.prototype={dispose:jsWorkFlow_Activities_NoopActivity$dispose,loadSerializeContext:jsWorkFlow_Activities_NoopActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_NoopActivity$saveSerializeContext,execute:jsWorkFlow_Activities_NoopActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.NoopActivity,'jsWorkFlow.Activities.NoopActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.GetExceptionActivity=function jsWorkFlow_Activities_GetExceptionActivity(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetExceptionActivity create!");jso.initializeBase(jsWorkFlow.Activities.GetExceptionActivity,this);};function jsWorkFlow_Activities_GetExceptionActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetExceptionActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.GetExceptionActivity,this,'dispose');}
function jsWorkFlow_Activities_GetExceptionActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetExceptionActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.GetExceptionActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.GetExceptionActivity,this,'loadSerializeContext',[baseSerializeContext]);}
function jsWorkFlow_Activities_GetExceptionActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetExceptionActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.GetExceptionActivity';var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.GetExceptionActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_GetExceptionActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetExceptionActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.GetExceptionActivity,this,'execute',[context]);var exception=null;var errorInfo=$jwf._getErrorInfo(context);if(errorInfo){exception=errorInfo.get_exception();}
context.set_result(exception);$jwf.endActivity(context);}
jsWorkFlow.Activities.GetExceptionActivity.prototype={dispose:jsWorkFlow_Activities_GetExceptionActivity$dispose,loadSerializeContext:jsWorkFlow_Activities_GetExceptionActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_GetExceptionActivity$saveSerializeContext,execute:jsWorkFlow_Activities_GetExceptionActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.GetExceptionActivity,'jsWorkFlow.Activities.GetExceptionActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.DataContextLayer=function jsWorkFlow_DataContextLayer(){throw new Error.notImplemented();};jsWorkFlow.DataContextLayer.prototype={auto:0,local:0,application:1,global:2};jso.registerEnum(jso.setTypeName(jsWorkFlow.DataContextLayer,'jsWorkFlow.DataContextLayer'));jsWorkFlow.Activities.DefineContextDataActivity=function jsWorkFlow_Activities_DefineContextDataActivity(dataKey,dataValueActivity,isPrivate,dataContextLayer){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity execute!");jso.initializeBase(jsWorkFlow.Activities.DefineContextDataActivity,this);if(typeof(dataContextLayer)==="undefined"){dataContextLayer=jsWorkFlow.DataContextLayer.auto;}
this._dataKey=dataKey;this._dataValueActivity=dataValueActivity;this._dataContextLayer=dataContextLayer;this._isPrivate=!!isPrivate;this._doEvalDataValueActivityCompleteHandler=jso.createDelegate(this,this.doEvalDataValueActivityCompleteHandler);};function jsWorkFlow_Activities_DefineContextDataActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.DefineContextDataActivity,this,'dispose');this._dataKey=null;this._dataValueActivity=null;}
function jsWorkFlow_Activities_DefineContextDataActivity$get_dataKey(){return this._dataKey;}
function jsWorkFlow_Activities_DefineContextDataActivity$set_dataKey(value){this._dataKey=value;}
function jsWorkFlow_Activities_DefineContextDataActivity$get_dataValueActivity(){return this._dataValueActivity;}
function jsWorkFlow_Activities_DefineContextDataActivity$set_dataValueActivity(value){this._dataValueActivity=value;}
function jsWorkFlow_Activities_DefineContextDataActivity$get_dataContextLayer(){return this._dataContextLayer;}
function jsWorkFlow_Activities_DefineContextDataActivity$set_dataContextLayer(value){this._dataContextLayer=value;}
function jsWorkFlow_Activities_DefineContextDataActivity$get_isPrivate(){return this._isPrivate;}
function jsWorkFlow_Activities_DefineContextDataActivity$set_isPrivate(value){this._isPrivate=!!value;}
function jsWorkFlow_Activities_DefineContextDataActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.DefineContextDataActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.DefineContextDataActivity,this,'loadSerializeContext',[baseSerializeContext]);var dataKey=serializeContext["dataKey"];this.set_dataKey(dataKey);var dataValueActivitySC=serializeContext["dataValueActivity"];var dataValueActivity=$jwf.loadActivity(dataValueActivitySC);this.set_dataValueActivity(dataValueActivity);var dataContextLayer=serializeContext["dataContextLayer"];this.set_dataContextLayer(dataContextLayer);var isPrivate=serializeContext["isPrivate"];this.set_isPrivate(isPrivate);}
function jsWorkFlow_Activities_DefineContextDataActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.DefineContextDataActivity';serializeContext["dataKey"]=this.get_dataKey();var dataValueActivity=this.get_dataValueActivity();serializeContext["dataValueActivity"]=$jwf.saveActivity(dataValueActivity);serializeContext["dataContextLayer"]=this.get_dataContextLayer();serializeContext["isPrivate"]=this.get_isPrivate();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.DefineContextDataActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_DefineContextDataActivity$doInitContextDataValue(application,value){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity doInitContextDataValue!");var dataContextLayer=this._dataContextLayer;var dataKey=this._dataKey;var isPrivate=this._isPrivate;var dataContext=null;if((jsWorkFlow.DataContextLayer.auto===dataContextLayer)||(jsWorkFlow.DataContextLayer.local===dataContextLayer)){dataContext=application.internalContextAt(1);}
else if(jsWorkFlow.DataContextLayer.application===dataContextLayer){dataContext=application.get_appContext();}
else if(jsWorkFlow.DataContextLayer.global===dataContextLayer){dataContext=application.get_globalContext();}
else{throw jso.errorInvalidOperation("Unknown dataContextLayer value ["+dataContextLayer+"]!");}
var isPublic=!isPrivate;var switchVisiblity=(dataContext.get_defaultVisibilityIsPublic()===isPublic)?false:true;dataContext.setData(dataKey,value,switchVisiblity);}
function jsWorkFlow_Activities_DefineContextDataActivity$doEvalDataValueActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity doEvalDataValueActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var application=parentContext.get_application();var result=null;executor.remove_postComplete(this._doEvalDataValueActivityCompleteHandler);result=context.get_result();parentContext.set_result(result);this.doInitContextDataValue(application,result);$jwf.endActivity(parentContext);}
function jsWorkFlow_Activities_DefineContextDataActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.DefineContextDataActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.DefineContextDataActivity,this,'execute',[context]);var activity=this._dataValueActivity;var application=context.get_application();if(!activity){this.doInitContextDataValue(application,null);$jwf.endActivity(context);return;}
var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalDataValueActivityCompleteHandler);activityExecutor.execute();}
jsWorkFlow.Activities.DefineContextDataActivity.prototype={_dataKey:null,_dataValueActivity:null,_dataContextLayer:0,_isPrivate:false,dispose:jsWorkFlow_Activities_DefineContextDataActivity$dispose,get_dataKey:jsWorkFlow_Activities_DefineContextDataActivity$get_dataKey,set_dataKey:jsWorkFlow_Activities_DefineContextDataActivity$set_dataKey,get_dataValueActivity:jsWorkFlow_Activities_DefineContextDataActivity$get_dataValueActivity,set_dataValueActivity:jsWorkFlow_Activities_DefineContextDataActivity$set_dataValueActivity,get_dataContextLayer:jsWorkFlow_Activities_DefineContextDataActivity$get_dataContextLayer,set_dataContextLayer:jsWorkFlow_Activities_DefineContextDataActivity$set_dataContextLayer,get_isPrivate:jsWorkFlow_Activities_DefineContextDataActivity$get_isPrivate,set_isPrivate:jsWorkFlow_Activities_DefineContextDataActivity$set_isPrivate,loadSerializeContext:jsWorkFlow_Activities_DefineContextDataActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_DefineContextDataActivity$saveSerializeContext,doInitContextDataValue:jsWorkFlow_Activities_DefineContextDataActivity$doInitContextDataValue,doEvalDataValueActivityCompleteHandler:jsWorkFlow_Activities_DefineContextDataActivity$doEvalDataValueActivityCompleteHandler,execute:jsWorkFlow_Activities_DefineContextDataActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.DefineContextDataActivity,'jsWorkFlow.Activities.DefineContextDataActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.GetContextDataActivity=function jsWorkFlow_Activities_GetContextDataActivity(dataKey,dataContextLayer){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetContextDataActivity execute!");jso.initializeBase(jsWorkFlow.Activities.GetContextDataActivity,this);if(typeof(dataContextLayer)==="undefined"){dataContextLayer=jsWorkFlow.DataContextLayer.auto;}
this._dataKey=dataKey;this._dataContextLayer=dataContextLayer;};function jsWorkFlow_Activities_GetContextDataActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetContextDataActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.GetContextDataActivity,this,'dispose');}
function jsWorkFlow_Activities_GetContextDataActivity$get_dataKey(){return this._dataKey;}
function jsWorkFlow_Activities_GetContextDataActivity$set_dataKey(value){this._dataKey=value;}
function jsWorkFlow_Activities_GetContextDataActivity$get_dataContextLayer(){return this._dataContextLayer;}
function jsWorkFlow_Activities_GetContextDataActivity$set_dataContextLayer(value){this._dataContextLayer=value;}
function jsWorkFlow_Activities_GetContextDataActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetContextDataActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.GetContextDataActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.GetContextDataActivity,this,'loadSerializeContext',[baseSerializeContext]);var dataKey=serializeContext["dataKey"];this.set_dataKey(dataKey);var dataContextLayer=serializeContext["dataContextLayer"];this.set_dataContextLayer(dataContextLayer);}
function jsWorkFlow_Activities_GetContextDataActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetContextDataActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.GetContextDataActivity';serializeContext["dataKey"]=this.get_dataKey();serializeContext["dataContextLayer"]=this.get_dataContextLayer();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.GetContextDataActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_GetContextDataActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetContextDataActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.GetContextDataActivity,this,'execute',[context]);var application=context.get_application();var dataKey=this.get_dataKey();var dataContextLayer=this.get_dataContextLayer();var result=null;if(jsWorkFlow.DataContextLayer.auto===dataContextLayer){result=application.getData(dataKey,1);}
else{var dataContext=null;if(jsWorkFlow.DataContextLayer.local===dataContextLayer){dataContext=application.internalContextAt(1);}
else if(jsWorkFlow.DataContextLayer.application===dataContextLayer){dataContext=application.get_appContext();}
else if(jsWorkFlow.DataContextLayer.global===dataContextLayer){dataContext=application.get_globalContext();}
else{throw jso.errorInvalidOperation("Unknown dataContextLayer value ["+dataContextLayer+"]!");}
result=dataContext.getData(dataKey);}
context.set_result(result);$jwf.endActivity(context);}
jsWorkFlow.Activities.GetContextDataActivity.prototype={_dataKey:null,_dataContextLayer:0,dispose:jsWorkFlow_Activities_GetContextDataActivity$dispose,get_dataKey:jsWorkFlow_Activities_GetContextDataActivity$get_dataKey,set_dataKey:jsWorkFlow_Activities_GetContextDataActivity$set_dataKey,get_dataContextLayer:jsWorkFlow_Activities_GetContextDataActivity$get_dataContextLayer,set_dataContextLayer:jsWorkFlow_Activities_GetContextDataActivity$set_dataContextLayer,loadSerializeContext:jsWorkFlow_Activities_GetContextDataActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_GetContextDataActivity$saveSerializeContext,execute:jsWorkFlow_Activities_GetContextDataActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.GetContextDataActivity,'jsWorkFlow.Activities.GetContextDataActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.SetContextDataActivity=function jsWorkFlow_Activities_SetContextDataActivity(dataKey,dataValueActivity,dataContextLayer){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity execute!");jso.initializeBase(jsWorkFlow.Activities.SetContextDataActivity,this);if(typeof(dataContextLayer)==="undefined"){dataContextLayer=jsWorkFlow.DataContextLayer.auto;}
this._dataKey=dataKey;this._dataValueActivity=dataValueActivity;this._dataContextLayer=dataContextLayer;this._doEvalDataValueActivityCompleteHandler=jso.createDelegate(this,this.doEvalDataValueActivityCompleteHandler);};function jsWorkFlow_Activities_SetContextDataActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.SetContextDataActivity,this,'dispose');this._dataKey=null;this._dataValueActivity=null;}
function jsWorkFlow_Activities_SetContextDataActivity$get_dataKey(){return this._dataKey;}
function jsWorkFlow_Activities_SetContextDataActivity$set_dataKey(value){this._dataKey=value;}
function jsWorkFlow_Activities_SetContextDataActivity$get_dataValueActivity(){return this._dataValueActivity;}
function jsWorkFlow_Activities_SetContextDataActivity$set_dataValueActivity(value){this._dataValueActivity=value;}
function jsWorkFlow_Activities_SetContextDataActivity$get_dataContextLayer(){return this._dataContextLayer;}
function jsWorkFlow_Activities_SetContextDataActivity$set_dataContextLayer(value){this._dataContextLayer=value;}
function jsWorkFlow_Activities_SetContextDataActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.SetContextDataActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.SetContextDataActivity,this,'loadSerializeContext',[baseSerializeContext]);var dataKey=serializeContext["dataKey"];this.set_dataKey(dataKey);var dataValueActivitySC=serializeContext["dataValueActivity"];var dataValueActivity=$jwf.loadActivity(dataValueActivitySC);this.set_dataValueActivity(dataValueActivity);var dataContextLayer=serializeContext["dataContextLayer"];this.set_dataContextLayer(dataContextLayer);var isPrivate=serializeContext["isPrivate"];}
function jsWorkFlow_Activities_SetContextDataActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.SetContextDataActivity';serializeContext["dataKey"]=this.get_dataKey();var dataValueActivity=this.get_dataValueActivity();serializeContext["dataValueActivity"]=$jwf.saveActivity(dataValueActivity);serializeContext["dataContextLayer"]=this.get_dataContextLayer();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.SetContextDataActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_SetContextDataActivity$doSetContextDataValue(application,value){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity doSetContextDataValue!");var dataContextLayer=this._dataContextLayer;var dataKey=this._dataKey;var result=false;if(jsWorkFlow.DataContextLayer.auto===dataContextLayer){var dataItem=application.getDataItem(dataKey,1);if(dataItem){dataItem.value=value;result=true;}}
else{if(jsWorkFlow.DataContextLayer.local===dataContextLayer){dataContext=application.internalContextAt(1);}
else if(jsWorkFlow.DataContextLayer.application===dataContextLayer){dataContext=application.get_appContext();}
else if(jsWorkFlow.DataContextLayer.global===dataContextLayer){dataContext=application.get_globalContext();}
else{throw jso.errorInvalidOperation("Unknown dataContextLayer value ["+dataContextLayer+"]!");}
var dataItem=dataContext.getDataItem(dataKey);if(dataItem){dataItem.value=value;result=true;}}
return result;}
function jsWorkFlow_Activities_SetContextDataActivity$doEvalDataValueActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity doEvalDataValueActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var application=parentContext.get_application();var dataValue=null;var result=false;executor.remove_postComplete(this._doEvalDataValueActivityCompleteHandler);dataValue=context.get_result();result=this.doSetContextDataValue(application,dataValue);parentContext.set_result(result);$jwf.endActivity(parentContext);}
function jsWorkFlow_Activities_SetContextDataActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetContextDataActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.SetContextDataActivity,this,'execute',[context]);var activity=this._dataValueActivity;var application=context.get_application();var result=false;if(!activity){result=this.doSetContextDataValue(application,null);context.set_result(result);$jwf.endActivity(context);return;}
var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalDataValueActivityCompleteHandler);activityExecutor.execute();}
jsWorkFlow.Activities.SetContextDataActivity.prototype={_dataKey:null,_dataValueActivity:null,_dataContextLayer:0,dispose:jsWorkFlow_Activities_SetContextDataActivity$dispose,get_dataKey:jsWorkFlow_Activities_SetContextDataActivity$get_dataKey,set_dataKey:jsWorkFlow_Activities_SetContextDataActivity$set_dataKey,get_dataValueActivity:jsWorkFlow_Activities_SetContextDataActivity$get_dataValueActivity,set_dataValueActivity:jsWorkFlow_Activities_SetContextDataActivity$set_dataValueActivity,get_dataContextLayer:jsWorkFlow_Activities_SetContextDataActivity$get_dataContextLayer,set_dataContextLayer:jsWorkFlow_Activities_SetContextDataActivity$set_dataContextLayer,loadSerializeContext:jsWorkFlow_Activities_SetContextDataActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_SetContextDataActivity$saveSerializeContext,doSetContextDataValue:jsWorkFlow_Activities_SetContextDataActivity$doSetContextDataValue,doEvalDataValueActivityCompleteHandler:jsWorkFlow_Activities_SetContextDataActivity$doEvalDataValueActivityCompleteHandler,execute:jsWorkFlow_Activities_SetContextDataActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.SetContextDataActivity,'jsWorkFlow.Activities.SetContextDataActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.ParallelActivity=function jsWorkFlow_Activities_ParallelActivity(activities){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity create!");jso.initializeBase(jsWorkFlow.Activities.ParallelActivity,this);this._activities=activities;this._doExecuteItemCompleteHandler=jso.createDelegate(this,this.doExecuteItemCompleteHandler);};function jsWorkFlow_Activities_ParallelActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.ParallelActivity,this,'dispose');}
function jsWorkFlow_Activities_ParallelActivity$get_activities(){return this._activities;}
function jsWorkFlow_Activities_ParallelActivity$set_activities(activities){if(!activities){activities=[];}
this._activities=activities;}
function jsWorkFlow_Activities_ParallelActivity$addActivity(activity){var activities=this.get_activities();jso.arrayAdd(activities,activity);}
function jsWorkFlow_Activities_ParallelActivity$removeActivity(activity){var activities=this.get_activities();Array.remove(activities,activity);}
function jsWorkFlow_Activities_ParallelActivity$removeActivityAt(index){var activities=this.get_activities();Array.removeAt(activities,index);}
function jsWorkFlow_Activities_ParallelActivity$clearActivity(){var activities=this.get_activities();Array.clear(activities);}
function jsWorkFlow_Activities_ParallelActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.ParallelActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.ParallelActivity,this,'loadSerializeContext',[baseSerializeContext]);var activities=[];var activitiesSC=serializeContext["activities"];if(activitiesSC&&(activitiesSC.length>0)){for(var i=0,ilen=activitiesSC.length;i<ilen;i++){var item=$jwf.loadActivity(activitiesSC[i]);jso.arrayAdd(activities,item);}}
this.set_activities(activities);}
function jsWorkFlow_Activities_ParallelActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.ParallelActivity';var activities=this.get_activities();var activitiesSC=[];if(activities&&(activities.length>0)){for(var i=0,ilen=activities.length;i<ilen;i++){var itemSC=$jwf.saveActivity(activities[i]);jso.arrayAdd(activitiesSC,itemSC);}}
serializeContext["activities"]=activitiesSC;var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.ParallelActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_ParallelActivity$doExecuteItem(context,activity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity doExecuteItem!");if(!activity){context.completeCount++;if(context.completeCount==context.totalActivity){$jwf.endActivity(context);}
return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doExecuteItemCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_ParallelActivity$doExecuteItemCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity doExecuteItemCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var condition=context.get_result();parentContext.completeCount++;if(parentContext.completeCount==parentContext.totalActivity){$jwf.endActivity(parentContext);}
return;}
function jsWorkFlow_Activities_ParallelActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ParallelActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.ParallelActivity,this,'execute',[context]);var activities=this.get_activities();if(!activities||(activities.length==0)){$jwf.endActivity(context);return;}
context.totalActivity=activities.length;context.completeCount=0;for(var i=0,ilen=activities.length;i<ilen;i++){var activity=activities[i];this.doExecuteItem(context,activity);}}
jsWorkFlow.Activities.ParallelActivity.prototype={_activities:null,_doExecuteItemCompleteHandler:null,dispose:jsWorkFlow_Activities_ParallelActivity$dispose,get_activities:jsWorkFlow_Activities_ParallelActivity$get_activities,set_activities:jsWorkFlow_Activities_ParallelActivity$set_activities,addActivity:jsWorkFlow_Activities_ParallelActivity$addActivity,removeActivity:jsWorkFlow_Activities_ParallelActivity$removeActivity,removeActivityAt:jsWorkFlow_Activities_ParallelActivity$removeActivityAt,clearActivity:jsWorkFlow_Activities_ParallelActivity$clearActivity,loadSerializeContext:jsWorkFlow_Activities_ParallelActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_ParallelActivity$saveSerializeContext,doExecuteItem:jsWorkFlow_Activities_ParallelActivity$doExecuteItem,doExecuteItemCompleteHandler:jsWorkFlow_Activities_ParallelActivity$doExecuteItemCompleteHandler,execute:jsWorkFlow_Activities_ParallelActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.ParallelActivity,'jsWorkFlow.Activities.ParallelActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.SequenceActivity=function jsWorkFlow_Activities_SequenceActivity(activities){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity create!");jso.initializeBase(jsWorkFlow.Activities.SequenceActivity,this);if(!activities){activities=[];}
this._activities=activities;this._doActivityCompleteHandler=jso.createDelegate(this,this.doActivityCompleteHandler);};function jsWorkFlow_Activities_SequenceActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.SequenceActivity,this,'dispose');this._activities=null;this._doActivityCompleteHandler=null;}
function jsWorkFlow_Activities_SequenceActivity$get_activities(){return this._activities;}
function jsWorkFlow_Activities_SequenceActivity$set_activities(value){this._activities=value;}
function jsWorkFlow_Activities_SequenceActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.SequenceActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.SequenceActivity,this,'loadSerializeContext',[baseSerializeContext]);var activitiesSC=serializeContext['activities'];var activities=[];if(activitiesSC&&(activitiesSC.length>0)){for(var i=0,ilen=activitiesSC.length;i<ilen;i++){var activity=$jwf.loadActivity(activitiesSC[i]);jso.arrayAdd(activities,activity);}}
this.set_activities(activities);}
function jsWorkFlow_Activities_SequenceActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.SequenceActivity';var activitiesSC=[];var activities=this.get_activities();if(activities&&(activities.length>0)){for(var i=0,ilen=activities.length;i<ilen;i++){var activitySC=$jwf.saveActivity(activities[i]);jso.arrayAdd(activitiesSC,activitySC);}}
serializeContext['activities']=activitiesSC;var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.SequenceActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_SequenceActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.SequenceActivity,this,'execute',[context]);this.doExecActivity(context,0);}
function jsWorkFlow_Activities_SequenceActivity$addActivity(activity){jso.arrayAdd(this._activities,activity);}
function jsWorkFlow_Activities_SequenceActivity$doExecActivity(context,index){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity doExecActivity!");if(index>=this._activities.length){$jwf.endActivity(context);return;}
var application=context.get_application();var activity=this._activities[index];var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.currentIndex=index;activityExecutor.add_postComplete(this._doActivityCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_SequenceActivity$doActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SequenceActivity doActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var currentIndex=executor.currentIndex;executor.remove_postComplete(this._doActivityCompleteHandler);var lastResult=context.get_result();parentContext.set_result(lastResult);currentIndex++;this.doExecActivity(parentContext,currentIndex);}
jsWorkFlow.Activities.SequenceActivity.prototype={_activities:null,_doActivityCompleteHandler:null,dispose:jsWorkFlow_Activities_SequenceActivity$dispose,get_activities:jsWorkFlow_Activities_SequenceActivity$get_activities,set_activities:jsWorkFlow_Activities_SequenceActivity$set_activities,loadSerializeContext:jsWorkFlow_Activities_SequenceActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_SequenceActivity$saveSerializeContext,execute:jsWorkFlow_Activities_SequenceActivity$execute,addActivity:jsWorkFlow_Activities_SequenceActivity$addActivity,doExecActivity:jsWorkFlow_Activities_SequenceActivity$doExecActivity,doActivityCompleteHandler:jsWorkFlow_Activities_SequenceActivity$doActivityCompleteHandler};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.SequenceActivity,'jsWorkFlow.Activities.SequenceActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.StateMachineActivity=function jsWorkFlow_Activities_StateMachineActivity(executeActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.StateMachineActivity create!");jso.initializeBase(jsWorkFlow.Activities.StateMachineActivity,this);this._executeActivity=executeActivity;};function jsWorkFlow_Activities_StateMachineActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.StateMachineActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.StateMachineActivity,this,'dispose');this._executeActivity=null;}
function jsWorkFlow_Activities_StateMachineActivity$get_executeActivity(){return this._executeActivity;}
function jsWorkFlow_Activities_StateMachineActivity$set_executeActivity(value){this._executeActivity=value;}
function jsWorkFlow_Activities_StateMachineActivity$notifyStateChanged(context,oldState,curState){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.StateMachineActivity notifyStateChanged!");log.debug("oldState:["+oldState+"]!");log.debug("curState:["+curState+"]!");jso.callBaseMethod(jsWorkFlow.Activities.StateMachineActivity,this,'notifyStateChanged',[context,oldState,curState]);if((jsWorkFlow.ActivityState.end===curState)||(jsWorkFlow.ActivityState.error===curState)){return;}
executeActivity=this.get_executeActivity();if(!executeActivity){$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,executeActivity,context);activityExecutor.execute();}
function jsWorkFlow_Activities_StateMachineActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.StateMachineActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.StateMachineActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.StateMachineActivity,this,'loadSerializeContext',[baseSerializeContext]);var executeActivitySC=serializeContext["executeActivity"];var executeActivity=$jwf.loadActivity(executeActivitySC);this.set_executeActivity(executeActivity);}
function jsWorkFlow_Activities_StateMachineActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.StateMachineActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.StateMachineActivity';var executeActivity=this.get_executeActivity();serializeContext["executeActivity"]=$jwf.saveActivity(executeActivity);var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.StateMachineActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_StateMachineActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.StateMachineActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.StateMachineActivity,this,'execute',[context]);}
jsWorkFlow.Activities.StateMachineActivity.prototype={_executeActivity:null,dispose:jsWorkFlow_Activities_StateMachineActivity$dispose,get_executeActivity:jsWorkFlow_Activities_StateMachineActivity$get_executeActivity,set_executeActivity:jsWorkFlow_Activities_StateMachineActivity$set_executeActivity,notifyStateChanged:jsWorkFlow_Activities_StateMachineActivity$notifyStateChanged,execute:jsWorkFlow_Activities_StateMachineActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.StateMachineActivity,'jsWorkFlow.Activities.StateMachineActivity'),jsWorkFlow.Activity);function $jwf$sm$findStateMachineContext(context){var retval=null;if(!context){return retval;}
var app=context.get_application();if(!app){return retval;}
var contextStack=app._contextStack;for(var i=0,ilen=contextStack.length;i<ilen;i++){var contextItem=contextStack[ilen-i-1];var contextItemAct=contextItem.get_activity();if(jso.isInstanceOfType(contextItemAct,jsWorkFlow.Activities.StateMachineActivity)){return contextItem;}}
return retval;}
jsWorkFlow.Activities.GetStateMachineStateActivity=function jsWorkFlow_Activities_GetStateMachineStateActivity(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetStateMachineStateActivity create!");jso.initializeBase(jsWorkFlow.Activities.GetStateMachineStateActivity,this);};function jsWorkFlow_Activities_GetStateMachineStateActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetStateMachineStateActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.GetStateMachineStateActivity,this,'dispose');}
function jsWorkFlow_Activities_GetStateMachineStateActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetStateMachineStateActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.GetStateMachineStateActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.GetStateMachineStateActivity,this,'loadSerializeContext',[baseSerializeContext]);}
function jsWorkFlow_Activities_GetStateMachineStateActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetStateMachineStateActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.GetStateMachineStateActivity';var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.GetStateMachineStateActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_GetStateMachineStateActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetStateMachineStateActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.GetStateMachineStateActivity,this,'execute',[context]);var smContext=$jwf$sm$findStateMachineContext(context);var smState=jsWorkFlow.ActivityState.none;if(smContext){smState=smContext.get_activityState();}
context.set_result(smState);$jwf.endActivity(context);}
jsWorkFlow.Activities.GetStateMachineStateActivity.prototype={dispose:jsWorkFlow_Activities_GetStateMachineStateActivity$dispose,loadSerializeContext:jsWorkFlow_Activities_GetStateMachineStateActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_GetStateMachineStateActivity$saveSerializeContext,execute:jsWorkFlow_Activities_GetStateMachineStateActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.GetStateMachineStateActivity,'jsWorkFlow.Activities.GetStateMachineStateActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.SetStateMachineStateActivity=function jsWorkFlow_Activities_SetStateMachineStateActivity(stateActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetStateMachineStateActivity create!");jso.initializeBase(jsWorkFlow.Activities.SetStateMachineStateActivity,this);this._stateActivity=stateActivity;this._doStateActivityCompleteHandler=jso.createDelegate(this,this.doStateActivityCompleteHandler);};function jsWorkFlow_Activities_SetStateMachineStateActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetStateMachineStateActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.SetStateMachineStateActivity,this,'dispose');this._stateActivity=null;this._doStateActivityCompleteHandler=null;}
function jsWorkFlow_Activities_SetStateMachineStateActivity$get_stateActivity(){return this._stateActivity;}
function jsWorkFlow_Activities_SetStateMachineStateActivity$set_stateActivity(value){this._stateActivity=value;}
function jsWorkFlow_Activities_SetStateMachineStateActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetStateMachineStateActivity loadSerializeContext!");if(serializeContext['_@_activityType']!==this.getType().getName()){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.SetStateMachineStateActivity,this,'loadSerializeContext',[baseSerializeContext]);var stateActivitySC=serializeContext["stateActivity"];var stateActivity=$jwf.loadActivity(stateActivitySC);this.set_stateActivity(stateActivity);}
function jsWorkFlow_Activities_SetStateMachineStateActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetStateMachineStateActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.SetStateMachineStateActivity';var stateActivity=this.get_stateActivity();serializeContext["stateActivity"]=$jwf.saveActivity(stateActivity);var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.SetStateMachineStateActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_SetStateMachineStateActivity$doStateActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetStateMachineStateActivity doStateActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var curState=context.get_result();var smContext=$jwf$sm$findStateMachineContext(context);var oldState=jsWorkFlow.ActivityState.none;if(smContext){oldState=smContext.get_activityState();smContext.set_activityState(curState);parentContext.set_result(oldState);}
else{}
$jwf.endActivity(parentContext);}
function jsWorkFlow_Activities_SetStateMachineStateActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SetStateMachineStateActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.SetStateMachineStateActivity,this,'execute',[context]);var stateActivity=this.get_stateActivity();if(!stateActivity){$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,stateActivity,context);activityExecutor.add_postComplete(this._doStateActivityCompleteHandler);activityExecutor.execute();}
jsWorkFlow.Activities.SetStateMachineStateActivity.prototype={_stateActivity:null,_doStateActivityCompleteHandler:null,dispose:jsWorkFlow_Activities_SetStateMachineStateActivity$dispose,get_stateActivity:jsWorkFlow_Activities_SetStateMachineStateActivity$get_stateActivity,set_stateActivity:jsWorkFlow_Activities_SetStateMachineStateActivity$set_stateActivity,loadSerializeContext:jsWorkFlow_Activities_SetStateMachineStateActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_SetStateMachineStateActivity$saveSerializeContext,doStateActivityCompleteHandler:jsWorkFlow_Activities_SetStateMachineStateActivity$doStateActivityCompleteHandler,execute:jsWorkFlow_Activities_SetStateMachineStateActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.SetStateMachineStateActivity,'jsWorkFlow.Activities.SetStateMachineStateActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.EndStateMachineActivity=function jsWorkFlow_Activities_EndStateMachineActivity(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EndStateMachineActivity create!");jso.initializeBase(jsWorkFlow.Activities.EndStateMachineActivity,this);};function jsWorkFlow_Activities_EndStateMachineActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EndStateMachineActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.EndStateMachineActivity,this,'dispose');}
function jsWorkFlow_Activities_EndStateMachineActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EndStateMachineActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.EndStateMachineActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.EndStateMachineActivity,this,'loadSerializeContext',[baseSerializeContext]);}
function jsWorkFlow_Activities_EndStateMachineActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EndStateMachineActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.EndStateMachineActivity';var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.EndStateMachineActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_EndStateMachineActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.EndStateMachineActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.EndStateMachineActivity,this,'execute',[context]);var smContext=$jwf$sm$findStateMachineContext(context);var oldState=jsWorkFlow.ActivityState.none;if(smContext){oldState=smContext.get_activityState();$jwf.endActivity(smContext);context.set_result(oldState);}
else{}
$jwf.endActivity(context);}
jsWorkFlow.Activities.EndStateMachineActivity.prototype={dispose:jsWorkFlow_Activities_EndStateMachineActivity$dispose,loadSerializeContext:jsWorkFlow_Activities_EndStateMachineActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_EndStateMachineActivity$saveSerializeContext,execute:jsWorkFlow_Activities_EndStateMachineActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.EndStateMachineActivity,'jsWorkFlow.Activities.EndStateMachineActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.SwitchActivity=function jsWorkFlow_Activities_SwitchActivity(conditionActivity,elseActivity,allCase){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity create!");jso.initializeBase(jsWorkFlow.Activities.SwitchActivity,this);this._conditionActivity=conditionActivity?conditionActivity:null;this._elseActivity=elseActivity?elseActivity:null;this._allCase=allCase?allCase:[];this._doEvalConditionCompleteHandler=jso.createDelegate(this,this.doEvalConditionCompleteHandler);this._doEvalCaseConditionCompleteHandler=jso.createDelegate(this,this.doEvalCaseConditionCompleteHandler);this._doExecuteCaseBodyCompleteHandler=jso.createDelegate(this,this.doExecuteCaseBodyCompleteHandler);this._doExecuteElseCaseCompleteHandler=jso.createDelegate(this,this.doExecuteElseCaseCompleteHandler);};function jsWorkFlow_Activities_SwitchActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity dispose!");this._conditionActivity=null;this._elseActivity=null;this._allCase=[];jso.callBaseMethod(jsWorkFlow.Activities.SwitchActivity,this,'dispose');}
function jsWorkFlow_Activities_SwitchActivity$get_conditionActivity(){return this._conditionActivity;}
function jsWorkFlow_Activities_SwitchActivity$set_conditionActivity(value){this._conditionActivity=value;}
function jsWorkFlow_Activities_SwitchActivity$get_elseActivity(){return this._elseActivity;}
function jsWorkFlow_Activities_SwitchActivity$set_elseActivity(value){this._elseActivity=value;}
function jsWorkFlow_Activities_SwitchActivity$get_allCase(){return this._allCase;}
function jsWorkFlow_Activities_SwitchActivity$set_allCase(value){this._allCase=value;}
function jsWorkFlow_Activities_SwitchActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.SwitchActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.SwitchActivity,this,'loadSerializeContext',[baseSerializeContext]);var conditionActivitySC=serializeContext["conditionActivity"];var conditionActivity=$jwf.loadActivity(conditionActivitySC);this.set_conditionActivity(conditionActivity);var elseActivitySC=serializeContext["elseActivity"];var elseActivity=$jwf.loadActivity(elseActivitySC);this.set_elseActivity(elseActivity);var allCase=[];var allCaseSC=serializeContext['allCase'];if(allCaseSC&&(allCaseSC.length>0)){for(var i=0,ilen=allCaseSC.length;i<ilen;i++){var caseItemSC=allCaseSC[i];var caseItem={};caseItem["key"]=$jwf.loadActivity(caseItemSC["key"]);caseItem["value"]=$jwf.loadActivity(caseItemSC["value"]);jso.arrayAdd(allCase,caseItem);}}
this.set_allCase(allCase);}
function jsWorkFlow_Activities_SwitchActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.SwitchActivity';var conditionActivity=this.get_conditionActivity();serializeContext["conditionActivity"]=$jwf.saveActivity(conditionActivity);var elseActivity=this.get_elseActivity();serializeContext["elseActivity"]=$jwf.saveActivity(elseActivity);var allCase=this.get_allCase();var allCaseSC=[];if(allCase&&(allCase.length>0)){for(var i=0,ilen=allCase.length;i<ilen;i++){var caseItem=allCase[i];var caseItemSC={};caseItemSC["key"]=$jwf.saveActivity(caseItem["key"]);caseItemSC["value"]=$jwf.saveActivity(caseItem["value"]);jso.arrayAdd(allCaseSC,caseItemSC);}}
serializeContext['allCase']=allCaseSC;var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.SwitchActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_SwitchActivity$addCase(caseConditionActivity,caseBodyActivity){var caseItem={};caseItem["key"]=caseConditionActivity;caseItem["value"]=caseBodyActivity;this.addCaseItem(caseItem);}
function jsWorkFlow_Activities_SwitchActivity$addCaseItem(caseItem){var allCase=this.get_allCase();jso.arrayAdd(allCase,caseItem);}
function jsWorkFlow_Activities_SwitchActivity$getCaseCount(){var allCase=this.get_allCase();return allCase.length;}
function jsWorkFlow_Activities_SwitchActivity$getCaseItemByIndex(index){var allCase=this.get_allCase();var caseItem=allCase[index];return caseItem;}
function jsWorkFlow_Activities_SwitchActivity$removeCaseItemByIndex(index){var allCase=this.get_allCase();var caseItem=allCase[index];Array.removeAt(index);return caseItem;}
function jsWorkFlow_Activities_SwitchActivity$clearAllCase(){var allCase=this.get_allCase();this.set_allCase([]);return allCase;}
function jsWorkFlow_Activities_SwitchActivity$doEvalCondition(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doEvalCondition!");var activity=this._conditionActivity;if(!activity){this.doEvalCaseCondition(context,null,0);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.parentContext=context;activityExecutor.add_postComplete(this._doEvalConditionCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_SwitchActivity$doEvalConditionCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doEvalConditionCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var condition=context.get_result();log.debug("condition is:["+condition+"]");this.doEvalCaseCondition(parentContext,condition,0);}
function jsWorkFlow_Activities_SwitchActivity$doEvalCaseCondition(context,condition,index){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doEvalCaseCondition!");log.debug("index is:["+index+"]");var allCase=this.get_allCase();if(index>=allCase.length){this.doExecuteElseCase(context);return;}
var caseItem=this.getCaseItemByIndex(index);var activity=caseItem["key"];if(!activity){if(condition===null){context.runCase=true;this.doExecuteCaseBody(context,index);}
return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.condition=condition;activityExecutor.currentIndex=index;activityExecutor.add_postComplete(this._doEvalCaseConditionCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_SwitchActivity$doEvalCaseConditionCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doEvalCaseConditionCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var condition=executor.condition;var index=executor.currentIndex;var caseCondition=context.get_result();log.debug("caseCondition is:["+caseCondition+"]");if(condition===caseCondition){parentContext.runCase=true;this.doExecuteCaseBody(parentContext,index);return;}
this.doEvalCaseCondition(parentContext,condition,index+1);}
function jsWorkFlow_Activities_SwitchActivity$doExecuteCaseBody(context,index){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doExecuteCaseBody!");var caseItem=this.getCaseItemByIndex(index);var activity=caseItem["value"];if(!activity){$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doExecuteCaseBodyCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_SwitchActivity$doExecuteCaseBodyCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doExecuteCaseBodyCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();$jwf.endActivity(parentContext);}
function jsWorkFlow_Activities_SwitchActivity$doExecuteElseCase(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doExecuteElseCase!");var activity=this._elseActivity;if(context.runCase||!activity){$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doExecuteElseCaseCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_SwitchActivity$doExecuteElseCaseCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity doExecuteElseCaseCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();$jwf.endActivity(parentContext);}
function jsWorkFlow_Activities_SwitchActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.SwitchActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.SwitchActivity,this,'execute',[context]);context.runCase=false;this.doEvalCondition(context);}
jsWorkFlow.Activities.SwitchActivity.prototype={_conditionActivity:null,_elseActivity:null,_allCase:null,_doEvalConditionCompleteHandler:null,_doEvalCaseConditionCompleteHandler:null,_doExecuteCaseBodyCompleteHandler:null,_doExecuteElseCaseCompleteHandler:null,dispose:jsWorkFlow_Activities_SwitchActivity$dispose,get_conditionActivity:jsWorkFlow_Activities_SwitchActivity$get_conditionActivity,set_conditionActivity:jsWorkFlow_Activities_SwitchActivity$set_conditionActivity,get_elseActivity:jsWorkFlow_Activities_SwitchActivity$get_elseActivity,set_elseActivity:jsWorkFlow_Activities_SwitchActivity$set_elseActivity,get_allCase:jsWorkFlow_Activities_SwitchActivity$get_allCase,set_allCase:jsWorkFlow_Activities_SwitchActivity$set_allCase,loadSerializeContext:jsWorkFlow_Activities_SwitchActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_SwitchActivity$saveSerializeContext,addCase:jsWorkFlow_Activities_SwitchActivity$addCase,addCaseItem:jsWorkFlow_Activities_SwitchActivity$addCaseItem,getCaseCount:jsWorkFlow_Activities_SwitchActivity$getCaseCount,getCaseItemByIndex:jsWorkFlow_Activities_SwitchActivity$getCaseItemByIndex,removeCaseItemByIndex:jsWorkFlow_Activities_SwitchActivity$removeCaseItemByIndex,clearAllCase:jsWorkFlow_Activities_SwitchActivity$clearAllCase,doEvalCondition:jsWorkFlow_Activities_SwitchActivity$doEvalCondition,doEvalConditionCompleteHandler:jsWorkFlow_Activities_SwitchActivity$doEvalConditionCompleteHandler,doEvalCaseCondition:jsWorkFlow_Activities_SwitchActivity$doEvalCaseCondition,doEvalCaseConditionCompleteHandler:jsWorkFlow_Activities_SwitchActivity$doEvalCaseConditionCompleteHandler,doExecuteCaseBody:jsWorkFlow_Activities_SwitchActivity$doExecuteCaseBody,doExecuteCaseBodyCompleteHandler:jsWorkFlow_Activities_SwitchActivity$doExecuteCaseBodyCompleteHandler,doExecuteElseCase:jsWorkFlow_Activities_SwitchActivity$doExecuteElseCase,doExecuteElseCaseCompleteHandler:jsWorkFlow_Activities_SwitchActivity$doExecuteElseCaseCompleteHandler,execute:jsWorkFlow_Activities_SwitchActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.SwitchActivity,'jsWorkFlow.Activities.SwitchActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.WhileActivity=function jsWorkFlow_Activities_WhileActivity(conditionActivity,bodyActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity create!");jso.initializeBase(jsWorkFlow.Activities.WhileActivity,this);this.set_conditionActivity(conditionActivity);this.set_bodyActivity(bodyActivity);this._doEvalConditionCompleteHandler=jso.createDelegate(this,this.doEvalConditionCompleteHandler);this._doExecuteBodyCompleteHandler=jso.createDelegate(this,this.doExecuteBodyCompleteHandler);};function jsWorkFlow_Activities_WhileActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.WhileActivity,this,'dispose');}
function jsWorkFlow_Activities_WhileActivity$get_conditionActivity(){return this._conditionActivity;}
function jsWorkFlow_Activities_WhileActivity$set_conditionActivity(value){this._conditionActivity=value;}
function jsWorkFlow_Activities_WhileActivity$get_bodyActivity(){return this._bodyActivity;}
function jsWorkFlow_Activities_WhileActivity$set_bodyActivity(value){this._bodyActivity=value;}
function jsWorkFlow_Activities_WhileActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.WhileActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.WhileActivity,this,'loadSerializeContext',[baseSerializeContext]);this.set_conditionActivity($jwf.loadActivity(serializeContext['conditionActivity']));this.set_bodyActivity($jwf.loadActivity(serializeContext['bodyActivity']));}
function jsWorkFlow_Activities_WhileActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.WhileActivity';serializeContext['conditionActivity']=$jwf.saveActivity(this.get_conditionActivity());serializeContext['bodyActivity']=$jwf.saveActivity(this.get_bodyActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.WhileActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_WhileActivity$doEvalCondition(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity doEvalCondition!");var activity=this._conditionActivity;if(!activity){this.doExecuteBody(context,false);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalConditionCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_WhileActivity$doEvalConditionCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity doEvalConditionCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var condition=context.get_result();log.debug("condition is:["+condition+"]");this.doExecuteBody(parentContext,condition);}
function jsWorkFlow_Activities_WhileActivity$doExecuteBody(context,condition){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity doExecuteBody!");if(!condition){$jwf.endActivity(context);return;}
var activity=this._bodyActivity;if(!activity){this.doEvalCondition(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doExecuteBodyCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_WhileActivity$doExecuteBodyCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity doExecuteBodyCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var result=context.get_result();parentContext.set_result(result);this.doEvalCondition(parentContext);}
function jsWorkFlow_Activities_WhileActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.WhileActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.WhileActivity,this,'execute',[context]);this.doEvalCondition(context);}
jsWorkFlow.Activities.WhileActivity.prototype={_conditionActivity:null,_bodyActivity:null,_doEvalConditionCompleteHandler:null,_doExecuteBodyCompleteHandler:null,dispose:jsWorkFlow_Activities_WhileActivity$dispose,get_conditionActivity:jsWorkFlow_Activities_WhileActivity$get_conditionActivity,set_conditionActivity:jsWorkFlow_Activities_WhileActivity$set_conditionActivity,get_bodyActivity:jsWorkFlow_Activities_WhileActivity$get_bodyActivity,set_bodyActivity:jsWorkFlow_Activities_WhileActivity$set_bodyActivity,loadSerializeContext:jsWorkFlow_Activities_WhileActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_WhileActivity$saveSerializeContext,doEvalCondition:jsWorkFlow_Activities_WhileActivity$doEvalCondition,doEvalConditionCompleteHandler:jsWorkFlow_Activities_WhileActivity$doEvalConditionCompleteHandler,doExecuteBody:jsWorkFlow_Activities_WhileActivity$doExecuteBody,doExecuteBodyCompleteHandler:jsWorkFlow_Activities_WhileActivity$doExecuteBodyCompleteHandler,execute:jsWorkFlow_Activities_WhileActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.WhileActivity,'jsWorkFlow.Activities.WhileActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.LogicAndActivity=function jsWorkFlow_Activities_LogicAndActivity(leftHandActivity,rightHandActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity create!");jso.initializeBase(jsWorkFlow.Activities.LogicAndActivity,this);this.set_leftHandActivity(leftHandActivity);this.set_rightHandActivity(rightHandActivity);this._doExecLhaCompleteHandler=jso.createDelegate(this,this.doExecLhaCompleteHandler);this._doExecRhaCompleteHandler=jso.createDelegate(this,this.doExecRhaCompleteHandler);};function jsWorkFlow_Activities_LogicAndActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.LogicAndActivity,this,'dispose');}
function jsWorkFlow_Activities_LogicAndActivity$get_leftHandActivity(){return this._leftHandActivity;}
function jsWorkFlow_Activities_LogicAndActivity$set_leftHandActivity(value){this._leftHandActivity=value;}
function jsWorkFlow_Activities_LogicAndActivity$get_rightHandActivity(){return this._rightHandActivity;}
function jsWorkFlow_Activities_LogicAndActivity$set_rightHandActivity(value){this._rightHandActivity=value;}
function jsWorkFlow_Activities_LogicAndActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.LogicAndActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.LogicAndActivity,this,'loadSerializeContext',[baseSerializeContext]);var leftHandActivitySC=serializeContext['leftHandActivity'];var leftHandActivity=$jwf.loadActivity(leftHandActivitySC);this.set_leftHandActivity(leftHandActivity);var rightHandActivitySC=serializeContext['rightHandActivity'];var rightHandActivity=$jwf.loadActivity(rightHandActivitySC);this.set_rightHandActivity(rightHandActivity);}
function jsWorkFlow_Activities_LogicAndActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.LogicAndActivity';serializeContext['leftHandActivity']=$jwf.saveActivity(this.get_leftHandActivity());serializeContext['rightHandActivity']=$jwf.saveActivity(this.get_rightHandActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.LogicAndActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_LogicAndActivity$doExecLha(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity doExecLha!");var lhaActivity=this._leftHandActivity;if(!lhaActivity){this.doExecRha(context,false);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,lhaActivity,context);activityExecutor.add_postComplete(this._doExecLhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicAndActivity$doExecLhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity doExecLhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var lhaResult=context.get_result();this.doExecRha(parentContext,lhaResult);return;}
function jsWorkFlow_Activities_LogicAndActivity$doExecRha(context,lhaResult){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity doExecRha!");if(!lhaResult){context.set_result(lhaResult);$jwf.endActivity(context);return;}
var rhaActivity=this._rightHandActivity;if(!rhaActivity){context.set_result(false);$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,rhaActivity,context);activityExecutor.add_postComplete(this._doExecRhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicAndActivity$doExecRhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity doExecRhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var result=context.get_result();parentContext.set_result(!!result);$jwf.endActivity(parentContext);return;}
function jsWorkFlow_Activities_LogicAndActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicAndActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.LogicAndActivity,this,'execute',[context]);this.doExecLha(context);}
jsWorkFlow.Activities.LogicAndActivity.prototype={_leftHandActivity:null,_rightHandActivity:null,_doExecLhaCompleteHandler:null,_doExecRhaCompleteHandler:null,dispose:jsWorkFlow_Activities_LogicAndActivity$dispose,get_leftHandActivity:jsWorkFlow_Activities_LogicAndActivity$get_leftHandActivity,set_leftHandActivity:jsWorkFlow_Activities_LogicAndActivity$set_leftHandActivity,get_rightHandActivity:jsWorkFlow_Activities_LogicAndActivity$get_rightHandActivity,set_rightHandActivity:jsWorkFlow_Activities_LogicAndActivity$set_rightHandActivity,loadSerializeContext:jsWorkFlow_Activities_LogicAndActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_LogicAndActivity$saveSerializeContext,doExecLha:jsWorkFlow_Activities_LogicAndActivity$doExecLha,doExecLhaCompleteHandler:jsWorkFlow_Activities_LogicAndActivity$doExecLhaCompleteHandler,doExecRha:jsWorkFlow_Activities_LogicAndActivity$doExecRha,doExecRhaCompleteHandler:jsWorkFlow_Activities_LogicAndActivity$doExecRhaCompleteHandler,execute:jsWorkFlow_Activities_LogicAndActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.LogicAndActivity,'jsWorkFlow.Activities.LogicAndActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.LogicOrActivity=function jsWorkFlow_Activities_LogicOrActivity(leftHandActivity,rightHandActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity create!");jso.initializeBase(jsWorkFlow.Activities.LogicOrActivity,this);this.set_leftHandActivity(leftHandActivity);this.set_rightHandActivity(rightHandActivity);this._doExecLhaCompleteHandler=jso.createDelegate(this,this.doExecLhaCompleteHandler);this._doExecRhaCompleteHandler=jso.createDelegate(this,this.doExecRhaCompleteHandler);};function jsWorkFlow_Activities_LogicOrActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.LogicOrActivity,this,'dispose');}
function jsWorkFlow_Activities_LogicOrActivity$get_leftHandActivity(){return this._leftHandActivity;}
function jsWorkFlow_Activities_LogicOrActivity$set_leftHandActivity(value){this._leftHandActivity=value;}
function jsWorkFlow_Activities_LogicOrActivity$get_rightHandActivity(){return this._rightHandActivity;}
function jsWorkFlow_Activities_LogicOrActivity$set_rightHandActivity(value){this._rightHandActivity=value;}
function jsWorkFlow_Activities_LogicOrActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.LogicOrActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.LogicOrActivity,this,'loadSerializeContext',[baseSerializeContext]);var leftHandActivitySC=serializeContext['leftHandActivity'];var leftHandActivity=$jwf.loadActivity(leftHandActivitySC);this.set_leftHandActivity(leftHandActivity);var rightHandActivitySC=serializeContext['rightHandActivity'];var rightHandActivity=$jwf.loadActivity(rightHandActivitySC);this.set_rightHandActivity(rightHandActivity);}
function jsWorkFlow_Activities_LogicOrActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.LogicOrActivity';serializeContext['leftHandActivity']=$jwf.saveActivity(this.get_leftHandActivity());serializeContext['rightHandActivity']=$jwf.saveActivity(this.get_rightHandActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.LogicOrActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_LogicOrActivity$doExecLha(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity doExecLha!");var lhaActivity=this._leftHandActivity;if(!lhaActivity){this.doExecRha(context,false);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,lhaActivity,context);activityExecutor.add_postComplete(this._doExecLhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicOrActivity$doExecLhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity doExecLhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var lhaResult=context.get_result();this.doExecRha(parentContext,lhaResult);return;}
function jsWorkFlow_Activities_LogicOrActivity$doExecRha(context,lhaResult){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity doExecRha!");if(lhaResult){context.set_result(lhaResult);$jwf.endActivity(context);return;}
var rhaActivity=this._rightHandActivity;if(!rhaActivity){context.set_result(false);$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,rhaActivity,context);activityExecutor.add_postComplete(this._doExecRhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicOrActivity$doExecRhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity doExecRhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var result=context.get_result();parentContext.set_result(!!result);$jwf.endActivity(parentContext);return;}
function jsWorkFlow_Activities_LogicOrActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicOrActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.LogicOrActivity,this,'execute',[context]);this.doExecLha(context);}
jsWorkFlow.Activities.LogicOrActivity.prototype={_leftHandActivity:null,_rightHandActivity:null,_doExecLhaCompleteHandler:null,_doExecRhaCompleteHandler:null,dispose:jsWorkFlow_Activities_LogicOrActivity$dispose,get_leftHandActivity:jsWorkFlow_Activities_LogicOrActivity$get_leftHandActivity,set_leftHandActivity:jsWorkFlow_Activities_LogicOrActivity$set_leftHandActivity,get_rightHandActivity:jsWorkFlow_Activities_LogicOrActivity$get_rightHandActivity,set_rightHandActivity:jsWorkFlow_Activities_LogicOrActivity$set_rightHandActivity,loadSerializeContext:jsWorkFlow_Activities_LogicOrActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_LogicOrActivity$saveSerializeContext,doExecLha:jsWorkFlow_Activities_LogicOrActivity$doExecLha,doExecLhaCompleteHandler:jsWorkFlow_Activities_LogicOrActivity$doExecLhaCompleteHandler,doExecRha:jsWorkFlow_Activities_LogicOrActivity$doExecRha,doExecRhaCompleteHandler:jsWorkFlow_Activities_LogicOrActivity$doExecRhaCompleteHandler,execute:jsWorkFlow_Activities_LogicOrActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.LogicOrActivity,'jsWorkFlow.Activities.LogicOrActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.LogicXorActivity=function jsWorkFlow_Activities_LogicXorActivity(leftHandActivity,rightHandActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity create!");jso.initializeBase(jsWorkFlow.Activities.LogicXorActivity,this);this.set_leftHandActivity(leftHandActivity);this.set_rightHandActivity(rightHandActivity);this._doExecLhaCompleteHandler=jso.createDelegate(this,this.doExecLhaCompleteHandler);this._doExecRhaCompleteHandler=jso.createDelegate(this,this.doExecRhaCompleteHandler);};function jsWorkFlow_Activities_LogicXorActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.LogicXorActivity,this,'dispose');}
function jsWorkFlow_Activities_LogicXorActivity$get_leftHandActivity(){return this._leftHandActivity;}
function jsWorkFlow_Activities_LogicXorActivity$set_leftHandActivity(value){this._leftHandActivity=value;}
function jsWorkFlow_Activities_LogicXorActivity$get_rightHandActivity(){return this._rightHandActivity;}
function jsWorkFlow_Activities_LogicXorActivity$set_rightHandActivity(value){this._rightHandActivity=value;}
function jsWorkFlow_Activities_LogicXorActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.LogicXorActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.LogicXorActivity,this,'loadSerializeContext',[baseSerializeContext]);var leftHandActivitySC=serializeContext['leftHandActivity'];var leftHandActivity=$jwf.loadActivity(leftHandActivitySC);this.set_leftHandActivity(leftHandActivity);var rightHandActivitySC=serializeContext['rightHandActivity'];var rightHandActivity=$jwf.loadActivity(rightHandActivitySC);this.set_rightHandActivity(rightHandActivity);}
function jsWorkFlow_Activities_LogicXorActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.LogicXorActivity';serializeContext['leftHandActivity']=$jwf.saveActivity(this.get_leftHandActivity());serializeContext['rightHandActivity']=$jwf.saveActivity(this.get_rightHandActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.LogicXorActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_LogicXorActivity$doExecLha(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity doExecLha!");var lhaActivity=this._leftHandActivity;if(!lhaActivity){this.doExecRha(context,false);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,lhaActivity,context);activityExecutor.add_postComplete(this._doExecLhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicXorActivity$doExecLhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity doExecLhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var lhaResult=context.get_result();this.doExecRha(parentContext,lhaResult);return;}
function jsWorkFlow_Activities_LogicXorActivity$doEvalXor(lhaResult,rhaResult){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity doEvalXor!");var lhaBit=0;var rhaBit=0;if(!!lhaResult){lhaBit=1;}
if(!!rhaResult){rhaBit=1;}
var result=lhaBit^rhaBit;return!!result;}
function jsWorkFlow_Activities_LogicXorActivity$doExecRha(context,lhaResult){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity doExecRha!");var rhaActivity=this._rightHandActivity;if(!rhaActivity){var result=this.doEvalXor(lhaResult,false);context.set_result(result);$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,rhaActivity,context);activityExecutor.lhaResult=lhaResult;activityExecutor.add_postComplete(this._doExecRhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicXorActivity$doExecRhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity doExecRhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var lhaResult=executor.lhaResult;var rhaResult=context.get_result();var result=this.doEvalXor(lhaResult,rhaResult);parentContext.set_result(!!result);$jwf.endActivity(parentContext);return;}
function jsWorkFlow_Activities_LogicXorActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicXorActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.LogicXorActivity,this,'execute',[context]);this.doExecLha(context);}
jsWorkFlow.Activities.LogicXorActivity.prototype={_leftHandActivity:null,_rightHandActivity:null,_doExecLhaCompleteHandler:null,_doExecRhaCompleteHandler:null,dispose:jsWorkFlow_Activities_LogicXorActivity$dispose,get_leftHandActivity:jsWorkFlow_Activities_LogicXorActivity$get_leftHandActivity,set_leftHandActivity:jsWorkFlow_Activities_LogicXorActivity$set_leftHandActivity,get_rightHandActivity:jsWorkFlow_Activities_LogicXorActivity$get_rightHandActivity,set_rightHandActivity:jsWorkFlow_Activities_LogicXorActivity$set_rightHandActivity,loadSerializeContext:jsWorkFlow_Activities_LogicXorActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_LogicXorActivity$saveSerializeContext,doExecLha:jsWorkFlow_Activities_LogicXorActivity$doExecLha,doExecLhaCompleteHandler:jsWorkFlow_Activities_LogicXorActivity$doExecLhaCompleteHandler,doEvalXor:jsWorkFlow_Activities_LogicXorActivity$doEvalXor,doExecRha:jsWorkFlow_Activities_LogicXorActivity$doExecRha,doExecRhaCompleteHandler:jsWorkFlow_Activities_LogicXorActivity$doExecRhaCompleteHandler,execute:jsWorkFlow_Activities_LogicXorActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.LogicXorActivity,'jsWorkFlow.Activities.LogicXorActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.LogicNotActivity=function jsWorkFlow_Activities_LogicNotActivity(activity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity create!");jso.initializeBase(jsWorkFlow.Activities.LogicNotActivity,this);this.set_activity(activity);this._doExecActivityCompleteHandler=jso.createDelegate(this,this.doExecActivityCompleteHandler);};function jsWorkFlow_Activities_LogicNotActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.LogicNotActivity,this,'dispose');}
function jsWorkFlow_Activities_LogicNotActivity$get_activity(){return this._activity;}
function jsWorkFlow_Activities_LogicNotActivity$set_activity(value){this._activity=value;}
function jsWorkFlow_Activities_LogicNotActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.LogicNotActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.LogicNotActivity,this,'loadSerializeContext',[baseSerializeContext]);var activitySC=serializeContext['activity'];var activity=$jwf.loadActivity(activitySC);this.set_activity(activity);}
function jsWorkFlow_Activities_LogicNotActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.LogicNotActivity';serializeContext['activity']=$jwf.saveActivity(this.get_activity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.LogicNotActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_LogicNotActivity$doExecActivity(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity doExecActivity!");var activity=this._activity;if(!activity){context.set_result(true);$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doExecActivityCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_LogicNotActivity$doExecActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity doExecActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var result=context.get_result();parentContext.set_result(!result);$jwf.endActivity(parentContext);return;}
function jsWorkFlow_Activities_LogicNotActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.LogicNotActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.LogicNotActivity,this,'execute',[context]);this.doExecActivity(context);}
jsWorkFlow.Activities.LogicNotActivity.prototype={_activity:null,_doExecActivityCompleteHandler:null,dispose:jsWorkFlow_Activities_LogicNotActivity$dispose,get_activity:jsWorkFlow_Activities_LogicNotActivity$get_activity,set_activity:jsWorkFlow_Activities_LogicNotActivity$set_activity,loadSerializeContext:jsWorkFlow_Activities_LogicNotActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_LogicNotActivity$saveSerializeContext,doExecActivity:jsWorkFlow_Activities_LogicNotActivity$doExecActivity,doExecActivityCompleteHandler:jsWorkFlow_Activities_LogicNotActivity$doExecActivityCompleteHandler,execute:jsWorkFlow_Activities_LogicNotActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.LogicNotActivity,'jsWorkFlow.Activities.LogicNotActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.ConstActivity=function jsWorkFlow_Activities_ConstActivity(constValue){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ConstActivity create!");jso.initializeBase(jsWorkFlow.Activities.ConstActivity,this);this.set_constValue(constValue);};function jsWorkFlow_Activities_ConstActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ConstActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.ConstActivity,this,'dispose');}
function jsWorkFlow_Activities_ConstActivity$get_constValue(){return this._constValue;}
function jsWorkFlow_Activities_ConstActivity$set_constValue(value){this._constValue=value;}
function jsWorkFlow_Activities_ConstActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ConstActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.ConstActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.ConstActivity,this,'loadSerializeContext',[baseSerializeContext]);var constValue=serializeContext["constValue"];this.set_constValue(constValue);}
function jsWorkFlow_Activities_ConstActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ConstActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.ConstActivity';serializeContext["constValue"]=this.get_constValue();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.ConstActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_ConstActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.ConstActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.ConstActivity,this,'execute',[context]);var constValue=this.get_constValue();context.set_result(constValue);$jwf.endActivity(context);}
jsWorkFlow.Activities.ConstActivity.prototype={_constValue:null,dispose:jsWorkFlow_Activities_ConstActivity$dispose,get_constValue:jsWorkFlow_Activities_ConstActivity$get_constValue,set_constValue:jsWorkFlow_Activities_ConstActivity$set_constValue,loadSerializeContext:jsWorkFlow_Activities_ConstActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_ConstActivity$saveSerializeContext,execute:jsWorkFlow_Activities_ConstActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.ConstActivity,'jsWorkFlow.Activities.ConstActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.CompareActivity=function jsWorkFlow_Activities_CompareActivity(leftHandActivity,rightHandActivity,strict){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity create!");jso.initializeBase(jsWorkFlow.Activities.CompareActivity,this);this.set_leftHandActivity(leftHandActivity);this.set_rightHandActivity(rightHandActivity);this.set_strict(strict);this._doExecLhaCompleteHandler=jso.createDelegate(this,this.doExecLhaCompleteHandler);this._doExecRhaCompleteHandler=jso.createDelegate(this,this.doExecRhaCompleteHandler);};function jsWorkFlow_Activities_CompareActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.CompareActivity,this,'dispose');}
function jsWorkFlow_Activities_CompareActivity$get_leftHandActivity(){return this._leftHandActivity;}
function jsWorkFlow_Activities_CompareActivity$set_leftHandActivity(value){this._leftHandActivity=value;}
function jsWorkFlow_Activities_CompareActivity$get_rightHandActivity(){return this._rightHandActivity;}
function jsWorkFlow_Activities_CompareActivity$set_rightHandActivity(value){this._rightHandActivity=value;}
function jsWorkFlow_Activities_CompareActivity$get_strict(){return this._strict;}
function jsWorkFlow_Activities_CompareActivity$set_strict(value){this._strict=value;}
function jsWorkFlow_Activities_CompareActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.CompareActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.CompareActivity,this,'loadSerializeContext',[baseSerializeContext]);var leftHandActivitySC=serializeContext['leftHandActivity'];var leftHandActivity=$jwf.loadActivity(leftHandActivitySC);this.set_leftHandActivity(leftHandActivity);var rightHandActivitySC=serializeContext['rightHandActivity'];var rightHandActivity=$jwf.loadActivity(rightHandActivitySC);this.set_rightHandActivity(rightHandActivity);var strict=serializeContext['strict'];this.set_strict(strict);}
function jsWorkFlow_Activities_CompareActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.CompareActivity';serializeContext['leftHandActivity']=$jwf.saveActivity(this.get_leftHandActivity());serializeContext['rightHandActivity']=$jwf.saveActivity(this.get_rightHandActivity());serializeContext['strict']=this.get_strict();var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.CompareActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_CompareActivity$doExecLha(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity doExecLha!");var lhaActivity=this._leftHandActivity;if(!lhaActivity){this.doExecRha(context,null);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,lhaActivity,context);activityExecutor.add_postComplete(this._doExecLhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_CompareActivity$doExecLhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity doExecLhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var lhaResult=context.get_result();this.doExecRha(parentContext,lhaResult);return;}
function jsWorkFlow_Activities_CompareActivity$doExecCompare(lhaResult,rhaResult){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity doExecCompare!");var strict=this._strict;var isEquals=(lhaResult==rhaResult);var result=0;if(strict){isEquals=(lhaResult===rhaResult);}
if(!isEquals){if(lhaResult>rhaResult){result=1;}
else{result=-1;}}
return result;}
function jsWorkFlow_Activities_CompareActivity$doExecRha(context,lhaResult){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity doExecRha!");var rhaActivity=this._rightHandActivity;if(!rhaActivity){var result=this.doExecCompare(lhaResult,null);context.set_result(result);$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,rhaActivity,context);activityExecutor.lhaResult=lhaResult;activityExecutor.add_postComplete(this._doExecRhaCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_CompareActivity$doExecRhaCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity doExecRhaCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var lhaResult=executor.lhaResult;var rhaResult=context.get_result();var result=this.doExecCompare(lhaResult,rhaResult);parentContext.set_result(result);$jwf.endActivity(parentContext);return;}
function jsWorkFlow_Activities_CompareActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.CompareActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.CompareActivity,this,'execute',[context]);this.doExecLha(context);}
jsWorkFlow.Activities.CompareActivity.prototype={_leftHandActivity:null,_rightHandActivity:null,_doExecLhaCompleteHandler:null,_doExecRhaCompleteHandler:null,_strict:false,dispose:jsWorkFlow_Activities_CompareActivity$dispose,get_leftHandActivity:jsWorkFlow_Activities_CompareActivity$get_leftHandActivity,set_leftHandActivity:jsWorkFlow_Activities_CompareActivity$set_leftHandActivity,get_rightHandActivity:jsWorkFlow_Activities_CompareActivity$get_rightHandActivity,set_rightHandActivity:jsWorkFlow_Activities_CompareActivity$set_rightHandActivity,get_strict:jsWorkFlow_Activities_CompareActivity$get_strict,set_strict:jsWorkFlow_Activities_CompareActivity$set_strict,loadSerializeContext:jsWorkFlow_Activities_CompareActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_CompareActivity$saveSerializeContext,doExecLha:jsWorkFlow_Activities_CompareActivity$doExecLha,doExecLhaCompleteHandler:jsWorkFlow_Activities_CompareActivity$doExecLhaCompleteHandler,doExecCompare:jsWorkFlow_Activities_CompareActivity$doExecCompare,doExecRha:jsWorkFlow_Activities_CompareActivity$doExecRha,doExecRhaCompleteHandler:jsWorkFlow_Activities_CompareActivity$doExecRhaCompleteHandler,execute:jsWorkFlow_Activities_CompareActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.CompareActivity,'jsWorkFlow.Activities.CompareActivity'),jsWorkFlow.Activity);jsWorkFlow.Activities.IsEqualsActivity=function jsWorkFlow_Activities_IsEqualsActivity(leftHandActivity,rightHandActivity,strict){jso.initializeBase(jsWorkFlow.Activities.IsEqualsActivity,this,[leftHandActivity,rightHandActivity,strict]);};function jsWorkFlow_Activities_IsEqualsActivity$dispose(){jso.callBaseMethod(jsWorkFlow.Activities.IsEqualsActivity,this,'dispose');}
function jsWorkFlow_Activities_IsEqualsActivity$loadSerializeContext(serializeContext){if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.IsEqualsActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.IsEqualsActivity,this,'loadSerializeContext',[baseSerializeContext]);}
function jsWorkFlow_Activities_IsEqualsActivity$saveSerializeContext(serializeContext){serializeContext['_@_activityType']='jsWorkFlow.Activities.IsEqualsActivity';var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.IsEqualsActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_IsEqualsActivity$doExecCompare(lhaResult,rhaResult){var strict=this._strict;var isEquals=(lhaResult==rhaResult);if(strict){isEquals=(lhaResult===rhaResult);}
return isEquals;}
function jsWorkFlow_Activities_IsEqualsActivity$execute(context){jso.callBaseMethod(jsWorkFlow.Activities.IsEqualsActivity,this,'execute',[context]);}
jsWorkFlow.Activities.IsEqualsActivity.prototype={dispose:jsWorkFlow_Activities_IsEqualsActivity$dispose,doExecCompare:jsWorkFlow_Activities_IsEqualsActivity$doExecCompare,execute:jsWorkFlow_Activities_IsEqualsActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.IsEqualsActivity,'jsWorkFlow.Activities.IsEqualsActivity'),jsWorkFlow.Activities.CompareActivity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.TryCatchActivity=function jsWorkFlow_Activities_TryCatchActivity(tryActivity,catchActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity create!");jso.initializeBase(jsWorkFlow.Activities.TryCatchActivity,this);this._tryActivity=tryActivity;this._catchActivity=catchActivity;this._doEvalTryCompleteHandler=jso.createDelegate(this,this.doEvalTryCompleteHandler);this._doEvalTryErrorHandler=jso.createDelegate(this,this.doEvalTryErrorHandler);this._doEvalTryErrorCompleteHandler=jso.createDelegate(this,this.doEvalTryErrorCompleteHandler);this._doEvalCatchCompleteHandler=jso.createDelegate(this,this.doEvalCatchCompleteHandler);};function jsWorkFlow_Activities_TryCatchActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.TryCatchActivity,this,'dispose');}
function jsWorkFlow_Activities_TryCatchActivity$get_tryActivity(){return this._tryActivity;}
function jsWorkFlow_Activities_TryCatchActivity$set_tryActivity(value){this._tryActivity=value;}
function jsWorkFlow_Activities_TryCatchActivity$get_catchActivity(){return this._catchActivity;}
function jsWorkFlow_Activities_TryCatchActivity$set_catchActivity(value){this._catchActivity=value;}
function jsWorkFlow_Activities_TryCatchActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.TryCatchActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.TryCatchActivity,this,'loadSerializeContext',[baseSerializeContext]);var tryActivitySC=serializeContext["tryActivity"];var tryActivity=$jwf.loadActivity(tryActivitySC);this.set_tryActivity(tryActivity);var catchActivitySC=serializeContext["catchActivity"];var catchActivity=$jwf.loadActivity(catchActivitySC);this.set_catchActivity(catchActivity);}
function jsWorkFlow_Activities_TryCatchActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.TryCatchActivity';serializeContext['tryActivity']=$jwf.saveActivity(this.get_tryActivity());serializeContext['catchActivity']=$jwf.saveActivity(this.get_catchActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.TryCatchActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_TryCatchActivity$doEvalTry(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity doEvalTry!");var activity=this._tryActivity;if(!activity){$jwf.endActivity(context);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalTryCompleteHandler);activityExecutor.add_error(this._doEvalTryErrorHandler);activityExecutor.add_errorComplete(this._doEvalTryErrorCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_TryCatchActivity$doEvalTryCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity doEvalTryCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();$jwf.endActivity(parentContext);}
function jsWorkFlow_Activities_TryCatchActivity$doEvalTryErrorHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity doEvalTryErrorHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();executor.set_deliverError(false);this.doEvalCatch(context);}
function jsWorkFlow_Activities_TryCatchActivity$doEvalTryErrorCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity doEvalTryErrorCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();executor.set_deliverError(true);executor.remove_error(this._doEvalTryErrorHandler);executor.remove_errorComplete(this._doEvalTryErrorCompleteHandler);}
function jsWorkFlow_Activities_TryCatchActivity$doEvalCatch(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity doEvalCatch!");var activity=this._catchActivity;if(!activity){$jwf.endActivity(parentContext);}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalCatchCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_TryCatchActivity$doEvalCatchCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity doEvalCatchCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var ppContext=parentContext.get_parentContext();$jwf.endActivity(ppContext);}
function jsWorkFlow_Activities_TryCatchActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.TryCatchActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.TryCatchActivity,this,'execute',[context]);this.doEvalTry(context);}
jsWorkFlow.Activities.TryCatchActivity.prototype={_tryActivity:null,_catchActivity:null,_doEvalTryCompleteHandler:null,_doEvalTryErrorHandler:null,_doEvalTryErrorCompleteHandler:null,_doEvalCatchCompleteHandler:null,dispose:jsWorkFlow_Activities_TryCatchActivity$dispose,get_tryActivity:jsWorkFlow_Activities_TryCatchActivity$get_tryActivity,set_tryActivity:jsWorkFlow_Activities_TryCatchActivity$set_tryActivity,get_catchActivity:jsWorkFlow_Activities_TryCatchActivity$get_catchActivity,set_catchActivity:jsWorkFlow_Activities_TryCatchActivity$set_catchActivity,loadSerializeContext:jsWorkFlow_Activities_TryCatchActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_TryCatchActivity$saveSerializeContext,doEvalTry:jsWorkFlow_Activities_TryCatchActivity$doEvalTry,doEvalTryCompleteHandler:jsWorkFlow_Activities_TryCatchActivity$doEvalTryCompleteHandler,doEvalTryErrorHandler:jsWorkFlow_Activities_TryCatchActivity$doEvalTryErrorHandler,doEvalTryErrorCompleteHandler:jsWorkFlow_Activities_TryCatchActivity$doEvalTryErrorCompleteHandler,doEvalCatch:jsWorkFlow_Activities_TryCatchActivity$doEvalCatch,doEvalCatchCompleteHandler:jsWorkFlow_Activities_TryCatchActivity$doEvalCatchCompleteHandler,execute:jsWorkFlow_Activities_TryCatchActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.TryCatchActivity,'jsWorkFlow.Activities.TryCatchActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.RaiseExceptionActivity=function jsWorkFlow_Activities_RaiseExceptionActivity(exceptionActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity create!");jso.initializeBase(jsWorkFlow.Activities.RaiseExceptionActivity,this);this._exceptionActivity=exceptionActivity;this._doEvalExceptionActivityCompleteHandler=jso.createDelegate(this,this.doEvalExceptionActivityCompleteHandler);};function jsWorkFlow_Activities_RaiseExceptionActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.RaiseExceptionActivity,this,'dispose');}
function jsWorkFlow_Activities_RaiseExceptionActivity$get_exceptionActivity(){return this._exceptionActivity;}
function jsWorkFlow_Activities_RaiseExceptionActivity$set_exceptionActivity(value){this._exceptionActivity=value;}
function jsWorkFlow_Activities_RaiseExceptionActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.RaiseExceptionActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.RaiseExceptionActivity,this,'loadSerializeContext',[baseSerializeContext]);var exceptionActivitySC=serializeContext["exceptionActivity"];var exceptionActivity=$jwf.loadActivity(exceptionActivitySC);this.set_exceptionActivity(exceptionActivity);}
function jsWorkFlow_Activities_RaiseExceptionActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.RaiseExceptionActivity';var exceptionActivity=this.get_exceptionActivity();serializeContext["exceptionActivity"]=$jwf.saveActivity(exceptionActivity);var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.RaiseExceptionActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_RaiseExceptionActivity$doEvalExceptionActivity(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity doEvalExceptionActivity!");var activity=this._exceptionActivity;if(!activity){this.doRaiseException(context,null,0);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalExceptionActivityCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_SwitchActivity$doEvalExceptionActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity doEvalExceptionActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var exceptionResult=context.get_result();log.debug("exceptionResult is:["+exceptionResult+"]");this.doRaiseException(parentContext,exceptionResult,0);}
function jsWorkFlow_Activities_SwitchActivity$doRaiseException(context,exceptionResult){$jwf.raiseError(context,exceptionResult);}
function jsWorkFlow_Activities_RaiseExceptionActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.RaiseExceptionActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.RaiseExceptionActivity,this,'execute',[context]);this.doEvalExceptionActivity(context);}
jsWorkFlow.Activities.RaiseExceptionActivity.prototype={_exceptionActivity:null,_doEvalExceptionActivityCompleteHandler:null,dispose:jsWorkFlow_Activities_RaiseExceptionActivity$dispose,get_exceptionActivity:jsWorkFlow_Activities_RaiseExceptionActivity$get_exceptionActivity,set_exceptionActivity:jsWorkFlow_Activities_RaiseExceptionActivity$set_exceptionActivity,loadSerializeContext:jsWorkFlow_Activities_RaiseExceptionActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_RaiseExceptionActivity$saveSerializeContext,doEvalExceptionActivity:jsWorkFlow_Activities_RaiseExceptionActivity$doEvalExceptionActivity,doEvalExceptionActivityCompleteHandler:jsWorkFlow_Activities_SwitchActivity$doEvalExceptionActivityCompleteHandler,doRaiseException:jsWorkFlow_Activities_SwitchActivity$doRaiseException,execute:jsWorkFlow_Activities_RaiseExceptionActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.RaiseExceptionActivity,'jsWorkFlow.Activities.RaiseExceptionActivity'),jsWorkFlow.Activity);

jso.ns('jsWorkFlow.Activities',true);var jsWorkFlow=jso.ns('jsWorkFlow');jsWorkFlow.Activities.GetTypeNameActivity=function jsWorkFlow_Activities_GetTypeNameActivity(objActivity){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity create!");jso.initializeBase(jsWorkFlow.Activities.GetTypeNameActivity,this);this._objActivity=objActivity;this._doEvalObjActivityCompleteHandler=jso.createDelegate(this,this.doEvalObjActivityCompleteHandler);};function jsWorkFlow_Activities_GetTypeNameActivity$dispose(){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity dispose!");jso.callBaseMethod(jsWorkFlow.Activities.GetTypeNameActivity,this,'dispose');}
function jsWorkFlow_Activities_GetTypeNameActivity$get_objActivity(){return this._objActivity;}
function jsWorkFlow_Activities_GetTypeNameActivity$set_objActivity(value){this._objActivity=value;}
function jsWorkFlow_Activities_GetTypeNameActivity$loadSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity loadSerializeContext!");if(serializeContext['_@_activityType']!=='jsWorkFlow.Activities.GetTypeNameActivity'){throw jso.errorInvalidOperation("loadSerializeContext missmatch type!");}
var baseSerializeContext=serializeContext['_@_base'];jso.callBaseMethod(jsWorkFlow.Activities.GetTypeNameActivity,this,'loadSerializeContext',[baseSerializeContext]);var objActivitySC=serializeContext["objActivity"];var objActivity=$jwf.loadActivity(objActivitySC);this.set_objActivity(objActivity);}
function jsWorkFlow_Activities_GetTypeNameActivity$saveSerializeContext(serializeContext){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity saveSerializeContext!");serializeContext['_@_activityType']='jsWorkFlow.Activities.GetTypeNameActivity';serializeContext['objActivity']=$jwf.saveActivity(this.get_objActivity());var baseSerializeContext={};jso.callBaseMethod(jsWorkFlow.Activities.GetTypeNameActivity,this,'saveSerializeContext',[baseSerializeContext]);serializeContext['_@_base']=baseSerializeContext;}
function jsWorkFlow_Activities_GetTypeNameActivity$doEvalObjActivity(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity doEvalObjActivity!");var activity=this._objActivity;if(!activity){this.doGetObjTypeName(context,null);return;}
var application=context.get_application();var activityExecutor=new jsWorkFlow.ActivityExecutor(application,activity,context);activityExecutor.add_postComplete(this._doEvalObjActivityCompleteHandler);activityExecutor.execute();}
function jsWorkFlow_Activities_GetTypeNameActivity$doEvalObjActivityCompleteHandler(sender,eventArgs){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity doEvalObjActivityCompleteHandler!");var context=eventArgs.get_context();var executor=context.get_executor();var parentContext=executor.get_parentContext();var obj=context.get_result();this.doGetObjTypeName(parentContext,obj);}
function jsWorkFlow_Activities_GetTypeNameActivity$doGetObjTypeName(context,obj){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity doGetObjTypeName!");var typeName="";if((typeof(obj)!=="undefined")&&(obj!==null)){var objType=jso.getInstanceType(obj);typeName=jso.getTypeName(objType);}
context.set_result(typeName);$jwf.endActivity(context);}
function jsWorkFlow_Activities_GetTypeNameActivity$execute(context){var log=jwf$getLogger();log.debug("jsWorkFlow.Activities.GetTypeNameActivity execute!");jso.callBaseMethod(jsWorkFlow.Activities.GetTypeNameActivity,this,'execute',[context]);this.doEvalObjActivity(context);}
jsWorkFlow.Activities.GetTypeNameActivity.prototype={_objActivity:null,_doEvalObjActivityCompleteHandler:null,dispose:jsWorkFlow_Activities_GetTypeNameActivity$dispose,get_objActivity:jsWorkFlow_Activities_GetTypeNameActivity$get_objActivity,set_objActivity:jsWorkFlow_Activities_GetTypeNameActivity$set_objActivity,loadSerializeContext:jsWorkFlow_Activities_GetTypeNameActivity$loadSerializeContext,saveSerializeContext:jsWorkFlow_Activities_GetTypeNameActivity$saveSerializeContext,doEvalObjActivity:jsWorkFlow_Activities_GetTypeNameActivity$doEvalObjActivity,doEvalObjActivityCompleteHandler:jsWorkFlow_Activities_GetTypeNameActivity$doEvalObjActivityCompleteHandler,doGetObjTypeName:jsWorkFlow_Activities_GetTypeNameActivity$doGetObjTypeName,execute:jsWorkFlow_Activities_GetTypeNameActivity$execute};jso.registerClass(jso.setTypeName(jsWorkFlow.Activities.GetTypeNameActivity,'jsWorkFlow.Activities.GetTypeNameActivity'),jsWorkFlow.Activity);
